// region key functions
	function get_rumola_key1() {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		var key = "db7669d04f6430b5";
		if (prefs.prefHasUserValue("rumola.key"))
			key = prefs.getCharPref("rumola.key").substr(0,16);
		return key;
	}
	function get_rumola_key2() {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		var key = "edf384db051f5d18";
		if (prefs.prefHasUserValue("rumola.key"))
			key = prefs.getCharPref("rumola.key").substr(16);
		return key;
	}
	function get_rumola_key2_sum() {
		var key = get_rumola_key2();
		var s=0;
		for (var i=0; i<16; i++) {
			s += key.charCodeAt(i);
		}
		return s;
	}

	function set_rumola_key(key) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		prefs.setCharPref("rumola.key", key);
	}
// endregion key functions

// region auto search functions
	function get_rumola_enabled() {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		var enabled = (prefs.prefHasUserValue("rumola.enabled")) ? prefs.getBoolPref("rumola.enabled") : true;
		return enabled;
	}
	function set_rumola_enabled(enabled) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		prefs.setBoolPref("rumola.enabled", enabled);
	}
	function change_rumola_enabled() {
		set_rumola_enabled(!get_rumola_enabled());
		if (!get_rumola_enabled())
			Services.wm.getMostRecentWindow("navigator:browser").gBrowser.contentWindow.rumola_top_window_message("Cancel", null);
	}
	var rumola_enabled_class = {
		observe: function(aSubject, aTopic, aData) {
			if (aTopic != "nsPref:changed")
				return;
			let wm = Cc["@mozilla.org/appshell/window-mediator;1"].
				getService(Ci.nsIWindowMediator);
			// Get the list of browser windows already open
			let windows = wm.getEnumerator("navigator:browser");
			while (windows.hasMoreElements()) {
				let domWindow = windows.getNext().QueryInterface(Ci.nsIDOMWindow);
				try
				{
					let doc = domWindow.document;
					var b = doc.getElementById("rumola-button");
					update_toolbar_button_icon_and_title(b);
				} catch (exc) {}
			}
		}
	}
// endregion auto search functions

// region switcher position
	function get_switcher_position() {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		if (prefs.prefHasUserValue("rumola.switcher"))
			return (prefs.getCharPref("rumola.switcher") == 'q') ? 'q' : 'p';
		return 'p';
	}
	function set_switcher_position(p) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		prefs.setCharPref("rumola.switcher", (p == 'q') ? 'q' : 'p');
	}
// endregion switcher position

// region voice notifications
	function get_rumola_voice() {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		var voice = (prefs.prefHasUserValue("rumola.voice_notifications")) ? prefs.getBoolPref("rumola.voice_notifications") : false;
		return voice;
	}
	function set_rumola_voice(v) {
		var value = v ? true : false;
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		prefs.setBoolPref("rumola.voice_notifications", value);
		if (value) {
			notify(loc_strings.GetStringFromName("voice_on"), false);
			voice_notification("notifications/on.wav");
		} else {
			notify(loc_strings.GetStringFromName("voice_off"), false);
		}
	}

	function voice_notification(f) {
		if (!get_rumola_voice())
			return;
		try
		{
			var browserWindow = Services.wm.getMostRecentWindow("navigator:browser");
			var audio_object = browserWindow.rumola_audio_object;
			if (!audio_object) {
				audio_object = new browserWindow.Audio();
				browserWindow.rumola_audio_object = audio_object;
			}
			audio_object.src = "chrome://rumola/content/"+f;
			audio_object.play();
		}
		catch (exc) {}
	}
// endregion voice notifications

// region auto solve domains functions
	function autosolve_get_domain(domain) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		if (!prefs.prefHasUserValue("rumola.auto_solve_domains"))
			return false;
		var domains = prefs.getCharPref("rumola.auto_solve_domains").split(",");
		for (var i=0; i<domains.length; i++) {
			if (domains[i] == '*')
				return domains[i];
			if ((domains[i].length > 2)&&(domains[i].substr(0,2) == '*.')&&(domains[i].substr(1) == domain.substr(0-domains[i].length+1)))
				return domains[i];
			if (domains[i] == domain)
				return domains[i];
		}
		return false;
	}

	function autosolve_add_domain(domain) {
		if ((""+domain).length < 3)
			return;
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		var v = "";
		if (prefs.prefHasUserValue("rumola.auto_solve_domains"))
			v = prefs.getCharPref("rumola.auto_solve_domains");
		if (v == "")
			prefs.setCharPref("rumola.auto_solve_domains", domain);
		else
			prefs.setCharPref("rumola.auto_solve_domains", v+','+domain);
	}

	function autosolve_remove_domain(domain) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		if (!prefs.prefHasUserValue("rumola.auto_solve_domains"))
			return false;
		var domains = prefs.getCharPref("rumola.auto_solve_domains").split(",");
		for (var i=0; i<domains.length; i++) {
			if (domains[i] == domain) {
				domains.splice(i, 1);
				prefs.setCharPref("rumola.auto_solve_domains", domains.join(","));
				return;
			}
		}
	}
// endregion auto solve domains functions

// region cached balance functions
	function get_cached_balance() {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		var balance = "?";
		if (prefs.prefHasUserValue("rumola.balance"))
			balance = prefs.getCharPref("rumola.balance");
		return balance;
	}
	function update_cached_balance(b) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		prefs.setCharPref("rumola.balance", b);
	}
// endregion cached balance functions

const {classes: Cc, interfaces: Ci, utils: Cu} = Components;
Cu.import("resource://gre/modules/Services.jsm");
let loc_strings = Services.strings.createBundle("chrome://rumola/locale/strings");
const XMLHttpRequest = Components.Constructor("@mozilla.org/xmlextras/xmlhttprequest;1", "nsIXMLHttpRequest");
const OBS = Cc['@mozilla.org/observer-service;1'].getService(Ci.nsIObserverService);
global_uninstalled = false;

// region all connect to server functions
	gate_urls = new Array();
	// language (l) will be fixed later
	gate_urls.push("https://gate1a.skipinput.com/q_gate.php?b=firefox&v=3001&l=??&key=");
	gate_urls.push("https://gate2a.skipinput.com/q_gate.php?b=firefox&v=3001&l=??&key=");
	gate_urls.push("https://gate.rumola.com/q_gate.php?b=firefox&v=3001&l=??&key=");

	tmp_variable = Math.round((new Date()).getTime()/100);
	gate_url_index = (get_rumola_key1() == 'db7669d04f6430b5') ? 0 : tmp_variable % 3;
	gate_url_vector = (tmp_variable % 2)*2-1;
	gate_suggested_index = -1;
	gate_url = gate_urls[gate_url_index];
	n_bad_responses_from_first_gate = 0;

	function change_rumola_gate_url(bNotify, bUseSuggested) {
		if (bNotify)
			n_bad_responses_from_first_gate++;
		if ((n_bad_responses_from_first_gate == 3)&&(bNotify)) {
			notify(loc_strings.GetStringFromName("conn_error"), false);
		}
		if (get_rumola_key1() == 'db7669d04f6430b5') {
			return;
		}
		gate_url_index = bUseSuggested ? gate_suggested_index : ((gate_url_index+gate_url_vector+6) % 3);
		gate_url = gate_urls[gate_url_index];
	}

	function process_response_heads(objHTTP) {
		if (objHTTP.getResponseHeader("apply_idle_mode"))
			objHTTP.sender_win.rumola_top_window_message("Cancel", null);
		if (objHTTP.getResponseHeader("rumola_key"))
			set_rumola_key(objHTTP.getResponseHeader("rumola_key"));
		if (objHTTP.getResponseHeader("rumola_credits"))
			update_cached_balance(objHTTP.getResponseHeader("rumola_credits"));
		if (objHTTP.getResponseHeader("DraftFilterVersion") && objHTTP.getResponseHeader("DraftFilterString"))
			set_regexes_string_and_version(objHTTP.getResponseHeader("DraftFilterString"), objHTTP.getResponseHeader("DraftFilterVersion"));
		if (objHTTP.getResponseHeader("ChangeGateSuggest") && (gate_suggested_index == -1)) {
			gate_suggested_index = parseInt(objHTTP.getResponseHeader("ChangeGateSuggest"));
			change_rumola_gate_url(false, true);
		}
	}

	callbacks_after_activation = new Array();
	function activate_and_callback(callback) {
		if (get_rumola_key1() == 'db7669d04f6430b5') {
			if (callbacks_after_activation.length > 0) {
				callbacks_after_activation.push(callback);
				return;
			}
			callbacks_after_activation.push(callback);

			var objHTTP = new XMLHttpRequest();
			var wm = Cc["@mozilla.org/appshell/window-mediator;1"].
				getService(Ci.nsIWindowMediator);
			var windows = wm.getEnumerator("navigator:browser");
			global_win = windows.getNext().QueryInterface(Ci.nsIDOMWindow);
			var u = gate_url+get_rumola_key1()+"&action=install&c1="+check_cheater_1()+"&c2="+check_cheater_2();
			delete global_win;
			objHTTP.open('POST', u, true);
			objHTTP.addEventListener("readystatechange", function(aEvent) {
				var objHTTP = aEvent.target;
				if (objHTTP.readyState != 4)
					return;

				if (objHTTP.status != 200) {
					notify(loc_strings.GetStringFromName("conn_error"), false);
					callbacks_after_activation = new Array();
					return;
				}
				process_response_heads(objHTTP);
				if (get_rumola_key1() == 'db7669d04f6430b5') {
					notify(loc_strings.GetStringFromName("conn_error"), false);
					callbacks_after_activation = new Array();
					return;
				}
				var tags = (""+objHTTP.responseText).split("||");
				if (tags[0])
					notify(tags[0], false);
				for (var i = 0; i < callbacks_after_activation.length; i++)
					callbacks_after_activation[i]();
				callbacks_after_activation = new Array();
			}, true);
			objHTTP.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
			objHTTP.send("");
		} else
			callback();
	}

	function send_request_to_second_gate(win, request) {
		var objHTTP = new XMLHttpRequest();

		objHTTP.sender_win = win;
		objHTTP.frame_id = request.frame_id;
		objHTTP.method = request.method;
		objHTTP.url = request.url;
		objHTTP.data = request.data;
		objHTTP.redo = 1;

		objHTTP.open(request.method, request.url, true);
		objHTTP.addEventListener("readystatechange", response_from_second_gate, true);
		objHTTP.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		objHTTP.send(request.data);
	}

	function send_request_to_first_gate(toGate, win, frame_id, step_id) {
		activate_and_callback(function() {
			var objHTTP = new XMLHttpRequest();

			objHTTP.sender_win = win;
			objHTTP.frame_id = frame_id;
			objHTTP.gate_url = gate_url;
			objHTTP.toGate = toGate;
			objHTTP.step_id = step_id;

			objHTTP.open('POST', gate_url+get_rumola_key1(), true);
			objHTTP.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
			objHTTP.setRequestHeader('DraftFilterVersion', get_regexes_version());
			objHTTP.setRequestHeader('SuggectedGate', ""+gate_suggested_index);
			objHTTP.addEventListener("readystatechange", response_from_first_gate, true);
			objHTTP.send("key="+get_rumola_key2()+"&fields=" + escape(toGate));
			win.setTimeout(function() {
				if (objHTTP.readyState != 4) {
					objHTTP.abort();
				}
			},7500);
		});
	}

	function response_from_first_gate(aEvent) {
		var objHTTP = aEvent.target;
		if (objHTTP.readyState != 4)
			return;

		if (objHTTP.status != 200) {
			if (objHTTP.gate_url == gate_url) {
				change_rumola_gate_url(true, false);
			}
			if (objHTTP.step_id == 1) {
				objHTTP.sender_win.setTimeout(function() {
					send_request_to_first_gate(objHTTP.toGate, objHTTP.sender_win, objHTTP.frame_id, 2);
				}, 250);
			}
			return;
		}
		process_response_heads(objHTTP);
		process_good_response_from_first_gate(""+objHTTP.responseText, objHTTP.sender_win, objHTTP.frame_id, objHTTP.getResponseHeader("BGate"));
	}

	function response_from_second_gate(aEvent) {
		var objHTTP = aEvent.target;
		if (objHTTP.readyState != 4)
			return;

		if (objHTTP.status != 200) {
			if (objHTTP.redo) {
				objHTTP.sender_win.setTimeout(function() {
					var objHTTP1 = new XMLHttpRequest();

					objHTTP1.sender_win = objHTTP.sender_win;
					objHTTP1.frame_id = objHTTP.frame_id;
					objHTTP1.redo = 0;

					objHTTP1.open(objHTTP.method, objHTTP.url, true);
					objHTTP1.addEventListener("readystatechange", response_from_second_gate, true);
					objHTTP1.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
					objHTTP1.send(objHTTP.data);
					}, 1500);
				return;
			}
			notify(loc_strings.GetStringFromName("conn_error"), false);
			objHTTP.sender_win.rumola_top_window_message("Cancel", null);
			return;
		}

		var tags = (""+objHTTP.responseText).split("||");

		if ((tags.length == 1)&&(tags[0])) {
			notify(tags[0], false);
		}

		if (tags.length > 1) {
			if (objHTTP.sender_win.rumola_top_window_message("ResponseFromSecondGate", {tags:tags, frame_id:objHTTP.frame_id}))
				if (tags[0])
					notify(tags[0], false);
		}
	}

	function process_good_response_from_first_gate(data, win, frame_id, b_gate_url) {
		n_bad_responses_from_first_gate = 0;

		var tags = data.split("||");

		if (win == null) {
			if (tags[0])
				notify(tags[0], false);
		} else {
			if ((tags.length == 1)&&(tags[0])) {
				notify(tags[0], false);
			}

			if (tags.length > 1) {
				if (win.rumola_top_window_message("ResponseFromFirstGate", {tags:tags, b_gate_url:b_gate_url, frame_id:frame_id}))
					if (tags[0]) {
						notify(tags[0], false);
					}
			}
		}
	}
// endregion all connect to server functions

// region notifications + notification clicks functions
	global_notify_counter = 0;
	function notify(s, need_solve_button) {
		var wait_time = 2600;
		var h = 185;
		var ih = new Array();
		var b = s.match(/{{[^}]+}}/g);
		if (b) {
			for (var i=0; i<b.length; i++) {
				var x = b[i].split("|");
				if (x[1] == "V") {
					voice_notification(x[2]);
				}
				if (x[1] == "T") {
					wait_time = parseInt(x[2]);
				}
				if (x[1] == "H") {
					h = parseInt(x[2]);
				}
				if (x[1] == "B") {
					ih.push(x);
				}
			}
		}
		s = s.replace(/{{[^}]+}}/g, '');
		var ts = s.split(/\|/);
		try {
			if (ih.length > 0) {
				if (ts.length == 2)
					s = ts[1]; // ignore title

				var browserWindow = Services.wm.getMostRecentWindow("navigator:browser");
				browserWindow.document.getElementById("rumola-panel").style.cssText = 'width: 340px; height: '+(h+25)+'px;';
				browserWindow.document.getElementById("rumola-panel").openPopup(browserWindow.document.getElementById("rumola-button"), 'after_start', 0, 0, false, false);
				browserWindow.document.getElementById("rumola-panel").childNodes[0].contentWindow.init(s, ih);

				var local_notify_counter = ++global_notify_counter;
				browserWindow.document.getElementById("rumola-panel").childNodes[0].contentWindow.setTimeout(function() {
					if (local_notify_counter == global_notify_counter)
						 browserWindow.document.getElementById("rumola-panel").hidePopup();
				}, wait_time);
			} else {
				var win = Components.classes['@mozilla.org/embedcomp/window-watcher;1'].
					getService(Components.interfaces.nsIWindowWatcher).  
					openWindow(null, 'chrome://global/content/alerts/alert.xul',  
					'_blank', 'chrome,titlebar=no,popup=yes', null);  
				if (ts.length == 2) {
					win.arguments = ["chrome://rumola/content/rumola48.png", ts[0], ts[1], false, ''];  	
				} else {
					win.arguments = ["chrome://rumola/content/rumola48.png", "Rumola", s, false, ''];  	
				}
			}
		} catch (exc) {}
	}
// endregion notifications + notification clicks functions

// region cheat control - just 1 time running on activation
	function check_cheater_1() {
		try {
			var _0x2cb6=["\x4E\x74\x74","\x77\x69\x64\x74\x68","\x73\x63\x72\x65\x65\x6E","\x2E","\x68\x65\x69\x67\x68\x74","\x0A","\x72\x65\x70\x6C\x61\x63\x65","","\x6C\x65\x6E\x67\x74\x68","\x63\x68\x61\x72\x43\x6F\x64\x65\x41\x74","\x66\x72\x6F\x6D\x43\x68\x61\x72\x43\x6F\x64\x65","\x30\x30\x30\x30\x30\x30\x30\x30\x20\x37\x37\x30\x37\x33\x30\x39\x36\x20\x45\x45\x30\x45\x36\x31\x32\x43\x20\x39\x39\x30\x39\x35\x31\x42\x41\x20\x30\x37\x36\x44\x43\x34\x31\x39\x20\x37\x30\x36\x41\x46\x34\x38\x46\x20\x45\x39\x36\x33\x41\x35\x33\x35\x20\x39\x45\x36\x34\x39\x35\x41\x33\x20\x30\x45\x44\x42\x38\x38\x33\x32\x20\x37\x39\x44\x43\x42\x38\x41\x34\x20\x45\x30\x44\x35\x45\x39\x31\x45\x20\x39\x37\x44\x32\x44\x39\x38\x38\x20\x30\x39\x42\x36\x34\x43\x32\x42\x20\x37\x45\x42\x31\x37\x43\x42\x44\x20\x45\x37\x42\x38\x32\x44\x30\x37\x20\x39\x30\x42\x46\x31\x44\x39\x31\x20\x31\x44\x42\x37\x31\x30\x36\x34\x20\x36\x41\x42\x30\x32\x30\x46\x32\x20\x46\x33\x42\x39\x37\x31\x34\x38\x20\x38\x34\x42\x45\x34\x31\x44\x45\x20\x31\x41\x44\x41\x44\x34\x37\x44\x20\x36\x44\x44\x44\x45\x34\x45\x42\x20\x46\x34\x44\x34\x42\x35\x35\x31\x20\x38\x33\x44\x33\x38\x35\x43\x37\x20\x31\x33\x36\x43\x39\x38\x35\x36\x20\x36\x34\x36\x42\x41\x38\x43\x30\x20\x46\x44\x36\x32\x46\x39\x37\x41\x20\x38\x41\x36\x35\x43\x39\x45\x43\x20\x31\x34\x30\x31\x35\x43\x34\x46\x20\x36\x33\x30\x36\x36\x43\x44\x39\x20\x46\x41\x30\x46\x33\x44\x36\x33\x20\x38\x44\x30\x38\x30\x44\x46\x35\x20\x33\x42\x36\x45\x32\x30\x43\x38\x20\x34\x43\x36\x39\x31\x30\x35\x45\x20\x44\x35\x36\x30\x34\x31\x45\x34\x20\x41\x32\x36\x37\x37\x31\x37\x32\x20\x33\x43\x30\x33\x45\x34\x44\x31\x20\x34\x42\x30\x34\x44\x34\x34\x37\x20\x44\x32\x30\x44\x38\x35\x46\x44\x20\x41\x35\x30\x41\x42\x35\x36\x42\x20\x33\x35\x42\x35\x41\x38\x46\x41\x20\x34\x32\x42\x32\x39\x38\x36\x43\x20\x44\x42\x42\x42\x43\x39\x44\x36\x20\x41\x43\x42\x43\x46\x39\x34\x30\x20\x33\x32\x44\x38\x36\x43\x45\x33\x20\x34\x35\x44\x46\x35\x43\x37\x35\x20\x44\x43\x44\x36\x30\x44\x43\x46\x20\x41\x42\x44\x31\x33\x44\x35\x39\x20\x32\x36\x44\x39\x33\x30\x41\x43\x20\x35\x31\x44\x45\x30\x30\x33\x41\x20\x43\x38\x44\x37\x35\x31\x38\x30\x20\x42\x46\x44\x30\x36\x31\x31\x36\x20\x32\x31\x42\x34\x46\x34\x42\x35\x20\x35\x36\x42\x33\x43\x34\x32\x33\x20\x43\x46\x42\x41\x39\x35\x39\x39\x20\x42\x38\x42\x44\x41\x35\x30\x46\x20\x32\x38\x30\x32\x42\x38\x39\x45\x20\x35\x46\x30\x35\x38\x38\x30\x38\x20\x43\x36\x30\x43\x44\x39\x42\x32\x20\x42\x31\x30\x42\x45\x39\x32\x34\x20\x32\x46\x36\x46\x37\x43\x38\x37\x20\x35\x38\x36\x38\x34\x43\x31\x31\x20\x43\x31\x36\x31\x31\x44\x41\x42\x20\x42\x36\x36\x36\x32\x44\x33\x44\x20\x37\x36\x44\x43\x34\x31\x39\x30\x20\x30\x31\x44\x42\x37\x31\x30\x36\x20\x39\x38\x44\x32\x32\x30\x42\x43\x20\x45\x46\x44\x35\x31\x30\x32\x41\x20\x37\x31\x42\x31\x38\x35\x38\x39\x20\x30\x36\x42\x36\x42\x35\x31\x46\x20\x39\x46\x42\x46\x45\x34\x41\x35\x20\x45\x38\x42\x38\x44\x34\x33\x33\x20\x37\x38\x30\x37\x43\x39\x41\x32\x20\x30\x46\x30\x30\x46\x39\x33\x34\x20\x39\x36\x30\x39\x41\x38\x38\x45\x20\x45\x31\x30\x45\x39\x38\x31\x38\x20\x37\x46\x36\x41\x30\x44\x42\x42\x20\x30\x38\x36\x44\x33\x44\x32\x44\x20\x39\x31\x36\x34\x36\x43\x39\x37\x20\x45\x36\x36\x33\x35\x43\x30\x31\x20\x36\x42\x36\x42\x35\x31\x46\x34\x20\x31\x43\x36\x43\x36\x31\x36\x32\x20\x38\x35\x36\x35\x33\x30\x44\x38\x20\x46\x32\x36\x32\x30\x30\x34\x45\x20\x36\x43\x30\x36\x39\x35\x45\x44\x20\x31\x42\x30\x31\x41\x35\x37\x42\x20\x38\x32\x30\x38\x46\x34\x43\x31\x20\x46\x35\x30\x46\x43\x34\x35\x37\x20\x36\x35\x42\x30\x44\x39\x43\x36\x20\x31\x32\x42\x37\x45\x39\x35\x30\x20\x38\x42\x42\x45\x42\x38\x45\x41\x20\x46\x43\x42\x39\x38\x38\x37\x43\x20\x36\x32\x44\x44\x31\x44\x44\x46\x20\x31\x35\x44\x41\x32\x44\x34\x39\x20\x38\x43\x44\x33\x37\x43\x46\x33\x20\x46\x42\x44\x34\x34\x43\x36\x35\x20\x34\x44\x42\x32\x36\x31\x35\x38\x20\x33\x41\x42\x35\x35\x31\x43\x45\x20\x41\x33\x42\x43\x30\x30\x37\x34\x20\x44\x34\x42\x42\x33\x30\x45\x32\x20\x34\x41\x44\x46\x41\x35\x34\x31\x20\x33\x44\x44\x38\x39\x35\x44\x37\x20\x41\x34\x44\x31\x43\x34\x36\x44\x20\x44\x33\x44\x36\x46\x34\x46\x42\x20\x34\x33\x36\x39\x45\x39\x36\x41\x20\x33\x34\x36\x45\x44\x39\x46\x43\x20\x41\x44\x36\x37\x38\x38\x34\x36\x20\x44\x41\x36\x30\x42\x38\x44\x30\x20\x34\x34\x30\x34\x32\x44\x37\x33\x20\x33\x33\x30\x33\x31\x44\x45\x35\x20\x41\x41\x30\x41\x34\x43\x35\x46\x20\x44\x44\x30\x44\x37\x43\x43\x39\x20\x35\x30\x30\x35\x37\x31\x33\x43\x20\x32\x37\x30\x32\x34\x31\x41\x41\x20\x42\x45\x30\x42\x31\x30\x31\x30\x20\x43\x39\x30\x43\x32\x30\x38\x36\x20\x35\x37\x36\x38\x42\x35\x32\x35\x20\x32\x30\x36\x46\x38\x35\x42\x33\x20\x42\x39\x36\x36\x44\x34\x30\x39\x20\x43\x45\x36\x31\x45\x34\x39\x46\x20\x35\x45\x44\x45\x46\x39\x30\x45\x20\x32\x39\x44\x39\x43\x39\x39\x38\x20\x42\x30\x44\x30\x39\x38\x32\x32\x20\x43\x37\x44\x37\x41\x38\x42\x34\x20\x35\x39\x42\x33\x33\x44\x31\x37\x20\x32\x45\x42\x34\x30\x44\x38\x31\x20\x42\x37\x42\x44\x35\x43\x33\x42\x20\x43\x30\x42\x41\x36\x43\x41\x44\x20\x45\x44\x42\x38\x38\x33\x32\x30\x20\x39\x41\x42\x46\x42\x33\x42\x36\x20\x30\x33\x42\x36\x45\x32\x30\x43\x20\x37\x34\x42\x31\x44\x32\x39\x41\x20\x45\x41\x44\x35\x34\x37\x33\x39\x20\x39\x44\x44\x32\x37\x37\x41\x46\x20\x30\x34\x44\x42\x32\x36\x31\x35\x20\x37\x33\x44\x43\x31\x36\x38\x33\x20\x45\x33\x36\x33\x30\x42\x31\x32\x20\x39\x34\x36\x34\x33\x42\x38\x34\x20\x30\x44\x36\x44\x36\x41\x33\x45\x20\x37\x41\x36\x41\x35\x41\x41\x38\x20\x45\x34\x30\x45\x43\x46\x30\x42\x20\x39\x33\x30\x39\x46\x46\x39\x44\x20\x30\x41\x30\x30\x41\x45\x32\x37\x20\x37\x44\x30\x37\x39\x45\x42\x31\x20\x46\x30\x30\x46\x39\x33\x34\x34\x20\x38\x37\x30\x38\x41\x33\x44\x32\x20\x31\x45\x30\x31\x46\x32\x36\x38\x20\x36\x39\x30\x36\x43\x32\x46\x45\x20\x46\x37\x36\x32\x35\x37\x35\x44\x20\x38\x30\x36\x35\x36\x37\x43\x42\x20\x31\x39\x36\x43\x33\x36\x37\x31\x20\x36\x45\x36\x42\x30\x36\x45\x37\x20\x46\x45\x44\x34\x31\x42\x37\x36\x20\x38\x39\x44\x33\x32\x42\x45\x30\x20\x31\x30\x44\x41\x37\x41\x35\x41\x20\x36\x37\x44\x44\x34\x41\x43\x43\x20\x46\x39\x42\x39\x44\x46\x36\x46\x20\x38\x45\x42\x45\x45\x46\x46\x39\x20\x31\x37\x42\x37\x42\x45\x34\x33\x20\x36\x30\x42\x30\x38\x45\x44\x35\x20\x44\x36\x44\x36\x41\x33\x45\x38\x20\x41\x31\x44\x31\x39\x33\x37\x45\x20\x33\x38\x44\x38\x43\x32\x43\x34\x20\x34\x46\x44\x46\x46\x32\x35\x32\x20\x44\x31\x42\x42\x36\x37\x46\x31\x20\x41\x36\x42\x43\x35\x37\x36\x37\x20\x33\x46\x42\x35\x30\x36\x44\x44\x20\x34\x38\x42\x32\x33\x36\x34\x42\x20\x44\x38\x30\x44\x32\x42\x44\x41\x20\x41\x46\x30\x41\x31\x42\x34\x43\x20\x33\x36\x30\x33\x34\x41\x46\x36\x20\x34\x31\x30\x34\x37\x41\x36\x30\x20\x44\x46\x36\x30\x45\x46\x43\x33\x20\x41\x38\x36\x37\x44\x46\x35\x35\x20\x33\x31\x36\x45\x38\x45\x45\x46\x20\x34\x36\x36\x39\x42\x45\x37\x39\x20\x43\x42\x36\x31\x42\x33\x38\x43\x20\x42\x43\x36\x36\x38\x33\x31\x41\x20\x32\x35\x36\x46\x44\x32\x41\x30\x20\x35\x32\x36\x38\x45\x32\x33\x36\x20\x43\x43\x30\x43\x37\x37\x39\x35\x20\x42\x42\x30\x42\x34\x37\x30\x33\x20\x32\x32\x30\x32\x31\x36\x42\x39\x20\x35\x35\x30\x35\x32\x36\x32\x46\x20\x43\x35\x42\x41\x33\x42\x42\x45\x20\x42\x32\x42\x44\x30\x42\x32\x38\x20\x32\x42\x42\x34\x35\x41\x39\x32\x20\x35\x43\x42\x33\x36\x41\x30\x34\x20\x43\x32\x44\x37\x46\x46\x41\x37\x20\x42\x35\x44\x30\x43\x46\x33\x31\x20\x32\x43\x44\x39\x39\x45\x38\x42\x20\x35\x42\x44\x45\x41\x45\x31\x44\x20\x39\x42\x36\x34\x43\x32\x42\x30\x20\x45\x43\x36\x33\x46\x32\x32\x36\x20\x37\x35\x36\x41\x41\x33\x39\x43\x20\x30\x32\x36\x44\x39\x33\x30\x41\x20\x39\x43\x30\x39\x30\x36\x41\x39\x20\x45\x42\x30\x45\x33\x36\x33\x46\x20\x37\x32\x30\x37\x36\x37\x38\x35\x20\x30\x35\x30\x30\x35\x37\x31\x33\x20\x39\x35\x42\x46\x34\x41\x38\x32\x20\x45\x32\x42\x38\x37\x41\x31\x34\x20\x37\x42\x42\x31\x32\x42\x41\x45\x20\x30\x43\x42\x36\x31\x42\x33\x38\x20\x39\x32\x44\x32\x38\x45\x39\x42\x20\x45\x35\x44\x35\x42\x45\x30\x44\x20\x37\x43\x44\x43\x45\x46\x42\x37\x20\x30\x42\x44\x42\x44\x46\x32\x31\x20\x38\x36\x44\x33\x44\x32\x44\x34\x20\x46\x31\x44\x34\x45\x32\x34\x32\x20\x36\x38\x44\x44\x42\x33\x46\x38\x20\x31\x46\x44\x41\x38\x33\x36\x45\x20\x38\x31\x42\x45\x31\x36\x43\x44\x20\x46\x36\x42\x39\x32\x36\x35\x42\x20\x36\x46\x42\x30\x37\x37\x45\x31\x20\x31\x38\x42\x37\x34\x37\x37\x37\x20\x38\x38\x30\x38\x35\x41\x45\x36\x20\x46\x46\x30\x46\x36\x41\x37\x30\x20\x36\x36\x30\x36\x33\x42\x43\x41\x20\x31\x31\x30\x31\x30\x42\x35\x43\x20\x38\x46\x36\x35\x39\x45\x46\x46\x20\x46\x38\x36\x32\x41\x45\x36\x39\x20\x36\x31\x36\x42\x46\x46\x44\x33\x20\x31\x36\x36\x43\x43\x46\x34\x35\x20\x41\x30\x30\x41\x45\x32\x37\x38\x20\x44\x37\x30\x44\x44\x32\x45\x45\x20\x34\x45\x30\x34\x38\x33\x35\x34\x20\x33\x39\x30\x33\x42\x33\x43\x32\x20\x41\x37\x36\x37\x32\x36\x36\x31\x20\x44\x30\x36\x30\x31\x36\x46\x37\x20\x34\x39\x36\x39\x34\x37\x34\x44\x20\x33\x45\x36\x45\x37\x37\x44\x42\x20\x41\x45\x44\x31\x36\x41\x34\x41\x20\x44\x39\x44\x36\x35\x41\x44\x43\x20\x34\x30\x44\x46\x30\x42\x36\x36\x20\x33\x37\x44\x38\x33\x42\x46\x30\x20\x41\x39\x42\x43\x41\x45\x35\x33\x20\x44\x45\x42\x42\x39\x45\x43\x35\x20\x34\x37\x42\x32\x43\x46\x37\x46\x20\x33\x30\x42\x35\x46\x46\x45\x39\x20\x42\x44\x42\x44\x46\x32\x31\x43\x20\x43\x41\x42\x41\x43\x32\x38\x41\x20\x35\x33\x42\x33\x39\x33\x33\x30\x20\x32\x34\x42\x34\x41\x33\x41\x36\x20\x42\x41\x44\x30\x33\x36\x30\x35\x20\x43\x44\x44\x37\x30\x36\x39\x33\x20\x35\x34\x44\x45\x35\x37\x32\x39\x20\x32\x33\x44\x39\x36\x37\x42\x46\x20\x42\x33\x36\x36\x37\x41\x32\x45\x20\x43\x34\x36\x31\x34\x41\x42\x38\x20\x35\x44\x36\x38\x31\x42\x30\x32\x20\x32\x41\x36\x46\x32\x42\x39\x34\x20\x42\x34\x30\x42\x42\x45\x33\x37\x20\x43\x33\x30\x43\x38\x45\x41\x31\x20\x35\x41\x30\x35\x44\x46\x31\x42\x20\x32\x44\x30\x32\x45\x46\x38\x44","\x30\x78","\x73\x75\x62\x73\x74\x72"];str=_0x2cb6[0]+global_win[_0x2cb6[2]][_0x2cb6[1]]+_0x2cb6[3]+global_win[_0x2cb6[2]][_0x2cb6[4]];str=str[_0x2cb6[6]](/\r\n/g,_0x2cb6[5]);var utftext=_0x2cb6[7];for(var n=0;n<str[_0x2cb6[8]];n++){var c=str[_0x2cb6[9]](n);if(c<128){utftext+=String[_0x2cb6[10]](c);} else {if((c>127)&&(c<2048)){utftext+=String[_0x2cb6[10]]((c>>6)|192);utftext+=String[_0x2cb6[10]]((c&63)|128);} else {utftext+=String[_0x2cb6[10]]((c>>12)|224);utftext+=String[_0x2cb6[10]](((c>>6)&63)|128);utftext+=String[_0x2cb6[10]]((c&63)|128);} ;} ;} ;str=utftext;var table=_0x2cb6[11];var crc=0;var x=0;var y=0;crc=crc^(-1);for(var i=0,iTop=str[_0x2cb6[8]];i<iTop;i++){y=(crc^str[_0x2cb6[9]](i))&0xFF;x=_0x2cb6[12]+table[_0x2cb6[13]](y*9,8);crc=(crc>>>8)^x;} ;global_variable=crc^(-1);
			return parseInt(global_variable);
		} catch (exc) {
			return 0;
		}
	}

	function check_cheater_2() {
		try {
			var _0x3ed1=["","\x70\x6C\x75\x67\x69\x6E\x73","\x6E\x61\x76\x69\x67\x61\x74\x6F\x72","\x6C\x65\x6E\x67\x74\x68","\x66\x69\x6C\x65\x6E\x61\x6D\x65","\x0A","\x72\x65\x70\x6C\x61\x63\x65","\x63\x68\x61\x72\x43\x6F\x64\x65\x41\x74","\x66\x72\x6F\x6D\x43\x68\x61\x72\x43\x6F\x64\x65","\x30\x30\x30\x30\x30\x30\x30\x30\x20\x37\x37\x30\x37\x33\x30\x39\x36\x20\x45\x45\x30\x45\x36\x31\x32\x43\x20\x39\x39\x30\x39\x35\x31\x42\x41\x20\x30\x37\x36\x44\x43\x34\x31\x39\x20\x37\x30\x36\x41\x46\x34\x38\x46\x20\x45\x39\x36\x33\x41\x35\x33\x35\x20\x39\x45\x36\x34\x39\x35\x41\x33\x20\x30\x45\x44\x42\x38\x38\x33\x32\x20\x37\x39\x44\x43\x42\x38\x41\x34\x20\x45\x30\x44\x35\x45\x39\x31\x45\x20\x39\x37\x44\x32\x44\x39\x38\x38\x20\x30\x39\x42\x36\x34\x43\x32\x42\x20\x37\x45\x42\x31\x37\x43\x42\x44\x20\x45\x37\x42\x38\x32\x44\x30\x37\x20\x39\x30\x42\x46\x31\x44\x39\x31\x20\x31\x44\x42\x37\x31\x30\x36\x34\x20\x36\x41\x42\x30\x32\x30\x46\x32\x20\x46\x33\x42\x39\x37\x31\x34\x38\x20\x38\x34\x42\x45\x34\x31\x44\x45\x20\x31\x41\x44\x41\x44\x34\x37\x44\x20\x36\x44\x44\x44\x45\x34\x45\x42\x20\x46\x34\x44\x34\x42\x35\x35\x31\x20\x38\x33\x44\x33\x38\x35\x43\x37\x20\x31\x33\x36\x43\x39\x38\x35\x36\x20\x36\x34\x36\x42\x41\x38\x43\x30\x20\x46\x44\x36\x32\x46\x39\x37\x41\x20\x38\x41\x36\x35\x43\x39\x45\x43\x20\x31\x34\x30\x31\x35\x43\x34\x46\x20\x36\x33\x30\x36\x36\x43\x44\x39\x20\x46\x41\x30\x46\x33\x44\x36\x33\x20\x38\x44\x30\x38\x30\x44\x46\x35\x20\x33\x42\x36\x45\x32\x30\x43\x38\x20\x34\x43\x36\x39\x31\x30\x35\x45\x20\x44\x35\x36\x30\x34\x31\x45\x34\x20\x41\x32\x36\x37\x37\x31\x37\x32\x20\x33\x43\x30\x33\x45\x34\x44\x31\x20\x34\x42\x30\x34\x44\x34\x34\x37\x20\x44\x32\x30\x44\x38\x35\x46\x44\x20\x41\x35\x30\x41\x42\x35\x36\x42\x20\x33\x35\x42\x35\x41\x38\x46\x41\x20\x34\x32\x42\x32\x39\x38\x36\x43\x20\x44\x42\x42\x42\x43\x39\x44\x36\x20\x41\x43\x42\x43\x46\x39\x34\x30\x20\x33\x32\x44\x38\x36\x43\x45\x33\x20\x34\x35\x44\x46\x35\x43\x37\x35\x20\x44\x43\x44\x36\x30\x44\x43\x46\x20\x41\x42\x44\x31\x33\x44\x35\x39\x20\x32\x36\x44\x39\x33\x30\x41\x43\x20\x35\x31\x44\x45\x30\x30\x33\x41\x20\x43\x38\x44\x37\x35\x31\x38\x30\x20\x42\x46\x44\x30\x36\x31\x31\x36\x20\x32\x31\x42\x34\x46\x34\x42\x35\x20\x35\x36\x42\x33\x43\x34\x32\x33\x20\x43\x46\x42\x41\x39\x35\x39\x39\x20\x42\x38\x42\x44\x41\x35\x30\x46\x20\x32\x38\x30\x32\x42\x38\x39\x45\x20\x35\x46\x30\x35\x38\x38\x30\x38\x20\x43\x36\x30\x43\x44\x39\x42\x32\x20\x42\x31\x30\x42\x45\x39\x32\x34\x20\x32\x46\x36\x46\x37\x43\x38\x37\x20\x35\x38\x36\x38\x34\x43\x31\x31\x20\x43\x31\x36\x31\x31\x44\x41\x42\x20\x42\x36\x36\x36\x32\x44\x33\x44\x20\x37\x36\x44\x43\x34\x31\x39\x30\x20\x30\x31\x44\x42\x37\x31\x30\x36\x20\x39\x38\x44\x32\x32\x30\x42\x43\x20\x45\x46\x44\x35\x31\x30\x32\x41\x20\x37\x31\x42\x31\x38\x35\x38\x39\x20\x30\x36\x42\x36\x42\x35\x31\x46\x20\x39\x46\x42\x46\x45\x34\x41\x35\x20\x45\x38\x42\x38\x44\x34\x33\x33\x20\x37\x38\x30\x37\x43\x39\x41\x32\x20\x30\x46\x30\x30\x46\x39\x33\x34\x20\x39\x36\x30\x39\x41\x38\x38\x45\x20\x45\x31\x30\x45\x39\x38\x31\x38\x20\x37\x46\x36\x41\x30\x44\x42\x42\x20\x30\x38\x36\x44\x33\x44\x32\x44\x20\x39\x31\x36\x34\x36\x43\x39\x37\x20\x45\x36\x36\x33\x35\x43\x30\x31\x20\x36\x42\x36\x42\x35\x31\x46\x34\x20\x31\x43\x36\x43\x36\x31\x36\x32\x20\x38\x35\x36\x35\x33\x30\x44\x38\x20\x46\x32\x36\x32\x30\x30\x34\x45\x20\x36\x43\x30\x36\x39\x35\x45\x44\x20\x31\x42\x30\x31\x41\x35\x37\x42\x20\x38\x32\x30\x38\x46\x34\x43\x31\x20\x46\x35\x30\x46\x43\x34\x35\x37\x20\x36\x35\x42\x30\x44\x39\x43\x36\x20\x31\x32\x42\x37\x45\x39\x35\x30\x20\x38\x42\x42\x45\x42\x38\x45\x41\x20\x46\x43\x42\x39\x38\x38\x37\x43\x20\x36\x32\x44\x44\x31\x44\x44\x46\x20\x31\x35\x44\x41\x32\x44\x34\x39\x20\x38\x43\x44\x33\x37\x43\x46\x33\x20\x46\x42\x44\x34\x34\x43\x36\x35\x20\x34\x44\x42\x32\x36\x31\x35\x38\x20\x33\x41\x42\x35\x35\x31\x43\x45\x20\x41\x33\x42\x43\x30\x30\x37\x34\x20\x44\x34\x42\x42\x33\x30\x45\x32\x20\x34\x41\x44\x46\x41\x35\x34\x31\x20\x33\x44\x44\x38\x39\x35\x44\x37\x20\x41\x34\x44\x31\x43\x34\x36\x44\x20\x44\x33\x44\x36\x46\x34\x46\x42\x20\x34\x33\x36\x39\x45\x39\x36\x41\x20\x33\x34\x36\x45\x44\x39\x46\x43\x20\x41\x44\x36\x37\x38\x38\x34\x36\x20\x44\x41\x36\x30\x42\x38\x44\x30\x20\x34\x34\x30\x34\x32\x44\x37\x33\x20\x33\x33\x30\x33\x31\x44\x45\x35\x20\x41\x41\x30\x41\x34\x43\x35\x46\x20\x44\x44\x30\x44\x37\x43\x43\x39\x20\x35\x30\x30\x35\x37\x31\x33\x43\x20\x32\x37\x30\x32\x34\x31\x41\x41\x20\x42\x45\x30\x42\x31\x30\x31\x30\x20\x43\x39\x30\x43\x32\x30\x38\x36\x20\x35\x37\x36\x38\x42\x35\x32\x35\x20\x32\x30\x36\x46\x38\x35\x42\x33\x20\x42\x39\x36\x36\x44\x34\x30\x39\x20\x43\x45\x36\x31\x45\x34\x39\x46\x20\x35\x45\x44\x45\x46\x39\x30\x45\x20\x32\x39\x44\x39\x43\x39\x39\x38\x20\x42\x30\x44\x30\x39\x38\x32\x32\x20\x43\x37\x44\x37\x41\x38\x42\x34\x20\x35\x39\x42\x33\x33\x44\x31\x37\x20\x32\x45\x42\x34\x30\x44\x38\x31\x20\x42\x37\x42\x44\x35\x43\x33\x42\x20\x43\x30\x42\x41\x36\x43\x41\x44\x20\x45\x44\x42\x38\x38\x33\x32\x30\x20\x39\x41\x42\x46\x42\x33\x42\x36\x20\x30\x33\x42\x36\x45\x32\x30\x43\x20\x37\x34\x42\x31\x44\x32\x39\x41\x20\x45\x41\x44\x35\x34\x37\x33\x39\x20\x39\x44\x44\x32\x37\x37\x41\x46\x20\x30\x34\x44\x42\x32\x36\x31\x35\x20\x37\x33\x44\x43\x31\x36\x38\x33\x20\x45\x33\x36\x33\x30\x42\x31\x32\x20\x39\x34\x36\x34\x33\x42\x38\x34\x20\x30\x44\x36\x44\x36\x41\x33\x45\x20\x37\x41\x36\x41\x35\x41\x41\x38\x20\x45\x34\x30\x45\x43\x46\x30\x42\x20\x39\x33\x30\x39\x46\x46\x39\x44\x20\x30\x41\x30\x30\x41\x45\x32\x37\x20\x37\x44\x30\x37\x39\x45\x42\x31\x20\x46\x30\x30\x46\x39\x33\x34\x34\x20\x38\x37\x30\x38\x41\x33\x44\x32\x20\x31\x45\x30\x31\x46\x32\x36\x38\x20\x36\x39\x30\x36\x43\x32\x46\x45\x20\x46\x37\x36\x32\x35\x37\x35\x44\x20\x38\x30\x36\x35\x36\x37\x43\x42\x20\x31\x39\x36\x43\x33\x36\x37\x31\x20\x36\x45\x36\x42\x30\x36\x45\x37\x20\x46\x45\x44\x34\x31\x42\x37\x36\x20\x38\x39\x44\x33\x32\x42\x45\x30\x20\x31\x30\x44\x41\x37\x41\x35\x41\x20\x36\x37\x44\x44\x34\x41\x43\x43\x20\x46\x39\x42\x39\x44\x46\x36\x46\x20\x38\x45\x42\x45\x45\x46\x46\x39\x20\x31\x37\x42\x37\x42\x45\x34\x33\x20\x36\x30\x42\x30\x38\x45\x44\x35\x20\x44\x36\x44\x36\x41\x33\x45\x38\x20\x41\x31\x44\x31\x39\x33\x37\x45\x20\x33\x38\x44\x38\x43\x32\x43\x34\x20\x34\x46\x44\x46\x46\x32\x35\x32\x20\x44\x31\x42\x42\x36\x37\x46\x31\x20\x41\x36\x42\x43\x35\x37\x36\x37\x20\x33\x46\x42\x35\x30\x36\x44\x44\x20\x34\x38\x42\x32\x33\x36\x34\x42\x20\x44\x38\x30\x44\x32\x42\x44\x41\x20\x41\x46\x30\x41\x31\x42\x34\x43\x20\x33\x36\x30\x33\x34\x41\x46\x36\x20\x34\x31\x30\x34\x37\x41\x36\x30\x20\x44\x46\x36\x30\x45\x46\x43\x33\x20\x41\x38\x36\x37\x44\x46\x35\x35\x20\x33\x31\x36\x45\x38\x45\x45\x46\x20\x34\x36\x36\x39\x42\x45\x37\x39\x20\x43\x42\x36\x31\x42\x33\x38\x43\x20\x42\x43\x36\x36\x38\x33\x31\x41\x20\x32\x35\x36\x46\x44\x32\x41\x30\x20\x35\x32\x36\x38\x45\x32\x33\x36\x20\x43\x43\x30\x43\x37\x37\x39\x35\x20\x42\x42\x30\x42\x34\x37\x30\x33\x20\x32\x32\x30\x32\x31\x36\x42\x39\x20\x35\x35\x30\x35\x32\x36\x32\x46\x20\x43\x35\x42\x41\x33\x42\x42\x45\x20\x42\x32\x42\x44\x30\x42\x32\x38\x20\x32\x42\x42\x34\x35\x41\x39\x32\x20\x35\x43\x42\x33\x36\x41\x30\x34\x20\x43\x32\x44\x37\x46\x46\x41\x37\x20\x42\x35\x44\x30\x43\x46\x33\x31\x20\x32\x43\x44\x39\x39\x45\x38\x42\x20\x35\x42\x44\x45\x41\x45\x31\x44\x20\x39\x42\x36\x34\x43\x32\x42\x30\x20\x45\x43\x36\x33\x46\x32\x32\x36\x20\x37\x35\x36\x41\x41\x33\x39\x43\x20\x30\x32\x36\x44\x39\x33\x30\x41\x20\x39\x43\x30\x39\x30\x36\x41\x39\x20\x45\x42\x30\x45\x33\x36\x33\x46\x20\x37\x32\x30\x37\x36\x37\x38\x35\x20\x30\x35\x30\x30\x35\x37\x31\x33\x20\x39\x35\x42\x46\x34\x41\x38\x32\x20\x45\x32\x42\x38\x37\x41\x31\x34\x20\x37\x42\x42\x31\x32\x42\x41\x45\x20\x30\x43\x42\x36\x31\x42\x33\x38\x20\x39\x32\x44\x32\x38\x45\x39\x42\x20\x45\x35\x44\x35\x42\x45\x30\x44\x20\x37\x43\x44\x43\x45\x46\x42\x37\x20\x30\x42\x44\x42\x44\x46\x32\x31\x20\x38\x36\x44\x33\x44\x32\x44\x34\x20\x46\x31\x44\x34\x45\x32\x34\x32\x20\x36\x38\x44\x44\x42\x33\x46\x38\x20\x31\x46\x44\x41\x38\x33\x36\x45\x20\x38\x31\x42\x45\x31\x36\x43\x44\x20\x46\x36\x42\x39\x32\x36\x35\x42\x20\x36\x46\x42\x30\x37\x37\x45\x31\x20\x31\x38\x42\x37\x34\x37\x37\x37\x20\x38\x38\x30\x38\x35\x41\x45\x36\x20\x46\x46\x30\x46\x36\x41\x37\x30\x20\x36\x36\x30\x36\x33\x42\x43\x41\x20\x31\x31\x30\x31\x30\x42\x35\x43\x20\x38\x46\x36\x35\x39\x45\x46\x46\x20\x46\x38\x36\x32\x41\x45\x36\x39\x20\x36\x31\x36\x42\x46\x46\x44\x33\x20\x31\x36\x36\x43\x43\x46\x34\x35\x20\x41\x30\x30\x41\x45\x32\x37\x38\x20\x44\x37\x30\x44\x44\x32\x45\x45\x20\x34\x45\x30\x34\x38\x33\x35\x34\x20\x33\x39\x30\x33\x42\x33\x43\x32\x20\x41\x37\x36\x37\x32\x36\x36\x31\x20\x44\x30\x36\x30\x31\x36\x46\x37\x20\x34\x39\x36\x39\x34\x37\x34\x44\x20\x33\x45\x36\x45\x37\x37\x44\x42\x20\x41\x45\x44\x31\x36\x41\x34\x41\x20\x44\x39\x44\x36\x35\x41\x44\x43\x20\x34\x30\x44\x46\x30\x42\x36\x36\x20\x33\x37\x44\x38\x33\x42\x46\x30\x20\x41\x39\x42\x43\x41\x45\x35\x33\x20\x44\x45\x42\x42\x39\x45\x43\x35\x20\x34\x37\x42\x32\x43\x46\x37\x46\x20\x33\x30\x42\x35\x46\x46\x45\x39\x20\x42\x44\x42\x44\x46\x32\x31\x43\x20\x43\x41\x42\x41\x43\x32\x38\x41\x20\x35\x33\x42\x33\x39\x33\x33\x30\x20\x32\x34\x42\x34\x41\x33\x41\x36\x20\x42\x41\x44\x30\x33\x36\x30\x35\x20\x43\x44\x44\x37\x30\x36\x39\x33\x20\x35\x34\x44\x45\x35\x37\x32\x39\x20\x32\x33\x44\x39\x36\x37\x42\x46\x20\x42\x33\x36\x36\x37\x41\x32\x45\x20\x43\x34\x36\x31\x34\x41\x42\x38\x20\x35\x44\x36\x38\x31\x42\x30\x32\x20\x32\x41\x36\x46\x32\x42\x39\x34\x20\x42\x34\x30\x42\x42\x45\x33\x37\x20\x43\x33\x30\x43\x38\x45\x41\x31\x20\x35\x41\x30\x35\x44\x46\x31\x42\x20\x32\x44\x30\x32\x45\x46\x38\x44","\x30\x78","\x73\x75\x62\x73\x74\x72","\x77\x69\x64\x74\x68","\x73\x63\x72\x65\x65\x6E"];str=function (){var _0x7691x1=_0x3ed1[0];try{var _0x7691x2=global_win[_0x3ed1[2]][_0x3ed1[1]];for(var i=0;i<_0x7691x2[_0x3ed1[3]];i++){_0x7691x1+=_0x7691x2[i][_0x3ed1[4]];} ;} catch(e){} ;return _0x7691x1;} ();str=str[_0x3ed1[6]](/\r\n/g,_0x3ed1[5]);var utftext=_0x3ed1[0];for(var n=0;n<str[_0x3ed1[3]];n++){var c=str[_0x3ed1[7]](n);if(c<128){utftext+=String[_0x3ed1[8]](c);} else {if((c>127)&&(c<2048)){utftext+=String[_0x3ed1[8]]((c>>6)|192);utftext+=String[_0x3ed1[8]]((c&63)|128);} else {utftext+=String[_0x3ed1[8]]((c>>12)|224);utftext+=String[_0x3ed1[8]](((c>>6)&63)|128);utftext+=String[_0x3ed1[8]]((c&63)|128);} ;} ;} ;str=utftext;var table=_0x3ed1[9];var crc=0;var x=0;var y=0;crc=crc^(-1);for(var i=0,iTop=str[_0x3ed1[3]];i<iTop;i++){y=(crc^str[_0x3ed1[7]](i))&0xFF;x=_0x3ed1[10]+table[_0x3ed1[11]](y*9,8);crc=(crc>>>8)^x;} ;crc=crc^(-1);var z=0;for(var zz=0;global_win[_0x3ed1[13]][_0x3ed1[12]]>=(1<<zz);zz++){z+=((global_win[_0x3ed1[13]][_0x3ed1[12]]&(1<<zz))?2:1);} ;global_variable=z*(crc&((1<<26)-1));
			return parseInt(global_variable);
		} catch (exc) {return 0;}
	}
// endregion

// region abuses
	function send_abuse(type, comm) {
		var value = (type == 1) ? get_abuse_captcha_params() : comm;
		if (!value)
			return;
		var objHTTP = new XMLHttpRequest();
		objHTTP.open('GET', "https://gate1a.skipinput.com/abuse_gate_new.php?b=firefox&v=3001&key="+get_rumola_key1()+"&a="+value, true);
		objHTTP.addEventListener("readystatechange", response_from_abuse_gate, true);
		objHTTP.send(null);
		if (type == 1) {
			localStorage["rumola:last_recognised_captcha_time"] = 0;
		}
	}
	function response_from_abuse_gate(aEvent) {
		var objHTTP = aEvent.target;
		if (objHTTP.readyState != 4)
			return;


		if (objHTTP.responseText) {
			notify(objHTTP.responseText);
		}
	}
	function get_abuse_captcha_params() {
		if (!localStorage["rumola:last_recognised_captcha_time"])
			return null;
		var t = localStorage["rumola:last_recognised_captcha_time"];
		var ct = (new Date()).getTime()/1000;
		if ((ct - 600) > t)
			return null;
		return escape(localStorage["rumola:last_recognised_captcha_id"] + ":" + localStorage["rumola:last_recognised_captcha_value"]);
	}
// endregion abuses

// region of captcha regexes
	function get_regexes_string() {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		var line = (prefs.prefHasUserValue("rumola.filter_string_new")) ? prefs.getCharPref("rumola.filter_string_new") : 
			"[ck]apt?cha|robot|random|rnd|code|kod|geraimag|verif||solvemedia||solvemedia||capt?cha|IdMainDiv|realperson||capt?cha||[ck]ap|chal|check|code|kod|confir|guess|guven|ivc|response|secur|solu|spam|test|token|validat|verif|vrfcd|result|respuesta";
		return line;
	}
	function get_regexes_version() {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		var v = (prefs.prefHasUserValue("rumola.filter_version_new")) ? prefs.getIntPref("rumola.filter_version_new") : 5;
		return v;
	}
	function set_regexes_string_and_version(s, v) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		prefs.setCharPref("rumola.filter_string_new", s);
		prefs.setIntPref("rumola.filter_version_new", parseInt(v));
	}
// endregion of captcha regexes

// region extension preferences
	let optionObserver = {
		observe: function(subject, topic, data) {
			if (topic !== 'addon-options-displayed' || data !== '{1BFCBDFC-41DB-11E1-9FC4-D3C94824019B}') {
				return;
			}

			activate_and_callback(function() {
				let document = subject.QueryInterface(Ci.nsIDOMDocument);
				var o = document.getElementById('rumola-menu12');
				o.addEventListener('command', function(e) {
					var gBrowserWindow = Services.wm.getMostRecentWindow("navigator:browser").gBrowser;
					gBrowserWindow.selectedTab = gBrowserWindow.addTab("https://client.skipinput.com/like.php?k="+get_rumola_key1()+"&v="+get_rumola_key2_sum());
				}, false);
				var o = document.getElementById('rumola-menu9');
				o.label = loc_strings.GetStringFromName('menu9').replace('?', get_cached_balance());
				o.addEventListener('command', function(e) {
					var gBrowserWindow = Services.wm.getMostRecentWindow("navigator:browser").gBrowser;
					gBrowserWindow.selectedTab = gBrowserWindow.addTab("https://client.skipinput.com/?k="+get_rumola_key1()+"&v="+get_rumola_key2_sum());
				}, false);
				var o = document.getElementById('rumola-menu8');
				o.addEventListener('command', function(e) {
					var email = escape(document.getElementById('email').value);
					var pswd = escape(document.getElementById('password').value);
					var dataString = "action=login&email="+email+"&password="+pswd;
					var stringStream = Cc["@mozilla.org/io/string-input-stream;1"].createInstance(Ci.nsIStringInputStream);
					if ("data" in stringStream) // Gecko 1.9 or newer
						stringStream.data = dataString;
					else // 1.8 or older
						stringStream.setData(dataString, dataString.length);
					var postData = Cc["@mozilla.org/network/mime-input-stream;1"].createInstance(Ci.nsIMIMEInputStream);
					postData.addHeader("Content-Type", "application/x-www-form-urlencoded");
					postData.addContentLength = true;
					postData.setData(stringStream);
					var gBrowserWindow = Services.wm.getMostRecentWindow("navigator:browser").gBrowser;
					gBrowserWindow.selectedTab = gBrowserWindow.addTab("https://client.skipinput.com/?a=t&k="+get_rumola_key1()+"&v="+get_rumola_key2_sum(), {postData: postData});
				}, false);
				var o = document.getElementById('rumola-menu10');
				o.addEventListener('command', function(e) {
					set_rumola_voice(get_rumola_voice());
				}, false);
			});
		}
	}
// endregion extension preferences

var WindowListener = {
	// nsIWindowMediatorListener functions
	onOpenWindow: function(xulWindow) {
		// A new window has opened
		let domWindow = xulWindow.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindow);

		// Wait for it to finish loading
		domWindow.addEventListener("load", function listener() {
			domWindow.removeEventListener("load", listener, false);

			// If this is a browser window then setup its UI
			if (domWindow.document.documentElement.getAttribute("windowtype") == "navigator:browser")
				startup_window(domWindow);
		}, false);
	},

	onCloseWindow: function(xulWindow) {
	},

	onWindowTitleChange: function(xulWindow, newTitle) {
	}
}

function update_toolbar_button_icon_and_title(button) {
	var enabled = get_rumola_enabled();
	button.style.listStyleImage = enabled ? 'url("chrome://rumola/content/on.png")' : 'url("chrome://rumola/content/off.png")';
	button.setAttribute("tooltiptext", loc_strings.GetStringFromName(enabled ? "hint1" : "hint2"));
}
function startup_window(win) {
	// region - generate button, panel, menu items and validate menu items
		let doc = win.document;
		let button = doc.createElement("toolbarbutton");
		button.setAttribute("id", "rumola-button");
		button.setAttribute("type", "button");
		button.setAttribute("removable", "true");
		button.setAttribute("class", "toolbarbutton-1 chromeclass-toolbar-additional");
		button.setAttribute("label", "Rumola - bypass captcha");
		button.addEventListener("command", 
			function(evt) {
				activate_and_callback(function() {
					if (evt.target == button)
						evt.target.ownerDocument.getElementById("rumola-popup").openPopup(evt.target, 'after_start', 0, 0, false, false);
					if (evt.target.id == 'rumola-popup-menu1')
						change_rumola_enabled();
					if (evt.target.id == 'rumola-popup-menu3')
						Services.wm.getMostRecentWindow("navigator:browser").gBrowser.contentWindow.rumola_top_window_message("AutoSearch", null);
					if (evt.target.id == 'rumola-popup-menu4')
						Services.wm.getMostRecentWindow("navigator:browser").gBrowser.contentWindow.rumola_top_window_message("Cancel", null);
					if (evt.target.id == 'rumola-popup-menu5') {
						var browserWindow = Services.wm.getMostRecentWindow("navigator:browser").gBrowser.contentWindow;
						var abused_url = browserWindow.document.URL;
						var comm=browserWindow.prompt("To send a complaint about "+abused_url, "Please enter a short description of what you were doing. This will help us understand the problem (optional)");
						if (comm !== null) {
							send_abuse(2, escape(abused_url)+"&c="+escape(comm));
						}
					}
					var gBrowserWindow = Services.wm.getMostRecentWindow("navigator:browser").gBrowser;
					if (evt.target.id == 'rumola-popup-menu9')
						gBrowserWindow.selectedTab = gBrowserWindow.addTab("https://client.skipinput.com/?k="+get_rumola_key1()+"&v="+get_rumola_key2_sum());
					if (evt.target.id == 'rumola-popup-menu8')
						gBrowserWindow.selectedTab = gBrowserWindow.addTab("https://client.skipinput.com/?a=t&k="+get_rumola_key1()+"&v="+get_rumola_key2_sum());
					if (evt.target.id == 'rumola-popup-menu7')
						gBrowserWindow.selectedTab = gBrowserWindow.addTab("http://skipinput.com/");
					if (evt.target.id == 'rumola-popup-menu12')
						gBrowserWindow.selectedTab = gBrowserWindow.addTab("https://client.skipinput.com/like.php?k="+get_rumola_key1()+"&v="+get_rumola_key2_sum());
					if (evt.target.id == 'rumola-popup-menu10')
						set_rumola_voice(!get_rumola_voice());
				});
			}, false);
		update_toolbar_button_icon_and_title(button);
		restorePosition(doc, button);

		var toolbarbuttonPanel = doc.createElement('panel');
		toolbarbuttonPanel.setAttribute('id', 'rumola-panel');
		toolbarbuttonPanel.setAttribute('type', 'arrow');
		toolbarbuttonPanel.setAttribute('scrolling', 'no');
		var mainPopupSet = doc.querySelector('#mainPopupSet');
		mainPopupSet.appendChild(toolbarbuttonPanel);

		var iframe = doc.createElement('iframe');
		iframe.setAttribute('src', 'chrome://rumola/content/popover.html');
		iframe.setAttribute('scrolling', 'no');
		iframe.style.cssText = 'position: absolute; top: 0; left: 0; width: 310px;';
		toolbarbuttonPanel.appendChild(iframe);

		let menupopup = doc.createElement('menupopup');
		menupopup.setAttribute('id', 'rumola-popup');

		var menu_item = doc.createElement('menuitem');
		menu_item.setAttribute('class', 'menuitem-iconic');
		menu_item.setAttribute('id', 'rumola-popup-menu1');
		menupopup.appendChild(menu_item);

		var separator = doc.createElement('menuseparator');
		menupopup.appendChild(separator);

		var menu_item = doc.createElement('menuitem');
		menu_item.setAttribute('class', 'menuitem-iconic');
		menu_item.setAttribute('id', 'rumola-popup-menu3');
		menu_item.setAttribute('label', loc_strings.GetStringFromName('menu3'));
		menu_item.setAttribute('image', "chrome://rumola/content/popup_on.png");
		menupopup.appendChild(menu_item);

		var menu_item = doc.createElement('menuitem');
		menu_item.setAttribute('class', 'menuitem-iconic');
		menu_item.setAttribute('id', 'rumola-popup-menu4');
		menu_item.setAttribute('label', loc_strings.GetStringFromName('menu4'));
		menu_item.setAttribute('image', "chrome://rumola/content/popup_cancel.png");
		menupopup.appendChild(menu_item);

		var menu_item = doc.createElement('menuitem');
		menu_item.setAttribute('class', 'menuitem-iconic');
		menu_item.setAttribute('id', 'rumola-popup-menu5');
		menu_item.setAttribute('label', loc_strings.GetStringFromName('menu5'));
		menupopup.appendChild(menu_item);

		var separator = doc.createElement('menuseparator');
		menupopup.appendChild(separator);

		var menu_item = doc.createElement('menuitem');
		menu_item.setAttribute('class', 'menuitem-iconic');
		menu_item.setAttribute('id', 'rumola-popup-menu10');
		menupopup.appendChild(menu_item);

		var separator = doc.createElement('menuseparator');
		menupopup.appendChild(separator);

		var menu_item = doc.createElement('menuitem');
		menu_item.setAttribute('class', 'menuitem-iconic');
		menu_item.setAttribute('id', 'rumola-popup-menu9');
		menu_item.setAttribute('image', "chrome://rumola/content/money.png");
		menupopup.appendChild(menu_item);

		var menu_item = doc.createElement('menuitem');
		menu_item.setAttribute('class', 'menuitem-iconic');
		menu_item.setAttribute('id', 'rumola-popup-menu8');
		menu_item.setAttribute('label', loc_strings.GetStringFromName('menu8'));
		menu_item.setAttribute('image', "chrome://rumola/content/login.png");
		menupopup.appendChild(menu_item);

		var menu_item = doc.createElement('menuitem');
		menu_item.setAttribute('class', 'menuitem-iconic');
		menu_item.setAttribute('id', 'rumola-popup-menu7');
		menu_item.setAttribute('label', loc_strings.GetStringFromName('menu7'));
		menupopup.appendChild(menu_item);

		var separator = doc.createElement('menuseparator');
		menupopup.appendChild(separator);

		var menu_item = doc.createElement('menuitem');
		menu_item.setAttribute('class', 'menuitem-iconic');
		menu_item.setAttribute('id', 'rumola-popup-menu12');
		menu_item.setAttribute('label', loc_strings.GetStringFromName('menu12'));
		menu_item.setAttribute('image', "chrome://rumola/content/up16.png");
		menupopup.appendChild(menu_item);

		button.addEventListener("popupshowing", 
			function(evt) {
				var enabled = get_rumola_enabled();
				evt.target.childNodes[0].setAttribute('label', loc_strings.GetStringFromName(enabled ? 'menu1' : 'menu2'));
				evt.target.childNodes[0].setAttribute('image', enabled ? "chrome://rumola/content/popup_off.png" : "chrome://rumola/content/popup_on.png");

				var voice = get_rumola_voice();
				evt.target.childNodes[6].setAttribute('label', loc_strings.GetStringFromName(voice ? 'menu11' : 'menu10'));
				evt.target.childNodes[6].setAttribute('image', voice ? "" : "chrome://rumola/content/accessibility.png");

				evt.target.childNodes[8].setAttribute('label', loc_strings.GetStringFromName('menu9').replace('?', get_cached_balance()));
			}, false);
		button.appendChild(menupopup);

		var contextMenu = doc.getElementById("contentAreaContextMenu");
		if (contextMenu) {
			var menu = doc.createElement("menuitem");
			menu.setAttribute('id', 'rumola-contextmenu');
			menu.setAttribute('label', '-----');
			menu.setAttribute('class', 'menuitem-iconic');
			menu.setAttribute('image', "chrome://rumola/content/popup_on.png");
			contextMenu.appendChild(menu);

			contextMenu.addEventListener("popupshowing", 
				function(evt) {
					this.ownerDocument.getElementById("rumola-contextmenu").hidden = true;
					if ((evt.target.ownerDocument.popupNode instanceof evt.target.ownerDocument.defaultView.HTMLInputElement)&&(acceptable_input_type(evt.target.ownerDocument.popupNode.type, true))) {
						this.ownerDocument.getElementById("rumola-contextmenu").label = loc_strings.GetStringFromName('context2');
						this.ownerDocument.getElementById("rumola-contextmenu").hidden = false;
					}
					if (evt.target.ownerDocument.popupNode instanceof evt.target.ownerDocument.defaultView.HTMLImageElement) {
						this.ownerDocument.getElementById("rumola-contextmenu").label = loc_strings.GetStringFromName('context1');
						this.ownerDocument.getElementById("rumola-contextmenu").hidden = false;
					}
				}, false);

			contextMenu.addEventListener("command", 
				function(evt) {
					if (evt.target.id == "rumola-contextmenu") {
						var x = evt.target.ownerDocument.defaultView.gBrowser.getBrowserForDocument(evt.target.ownerDocument.popupNode.ownerDocument.defaultView.top.document);
						x.contentWindow.rumola_top_window_message("context", evt.target.ownerDocument.popupNode);
					}
				}, false);
		}
	// endregion

	var appcontent = doc.getElementById("appcontent");
	if (appcontent) {
		appcontent.addEventListener("DOMContentLoaded", 
			function(evt) {
				if (global_uninstalled)
					return;
				if (evt.originalTarget.defaultView != evt.originalTarget.defaultView.top)
					return;
				new global_rumola(evt.originalTarget.defaultView);
			}, false);
	}

}
function uninstall_window(win) {
	let doc = win.document;
	var b = doc.getElementById("rumola-button");
	b.parentNode.removeChild(b);

	var b = doc.getElementById("rumola-contextmenu");
	b.parentNode.removeChild(b);
}

function startup(data, reason) {
	if (ADDON_INSTALL == reason) {
		set_rumola_enabled(true);
		setDefaultPosition("rumola-button", "nav-bar", "downloads-button");
	}

	let wm = Cc["@mozilla.org/appshell/window-mediator;1"].
		getService(Ci.nsIWindowMediator);

	// Get the list of browser windows already open
	let windows = wm.getEnumerator("navigator:browser");
	while (windows.hasMoreElements()) {
		var domWindow = windows.getNext().QueryInterface(Ci.nsIDOMWindow);
		startup_window(domWindow);
	}

	// Wait for any new browser windows to open
	wm.addListener(WindowListener);

	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefBranch);
	prefs.addObserver("rumola.enabled", rumola_enabled_class, false);

	OBS.addObserver(optionObserver, 'addon-options-displayed', false);

	var lang = loc_strings.GetStringFromName("lang");
	for (var i=0; i<gate_urls.length; i++) {
		gate_urls[i] = gate_urls[i].replace('l=??', 'l='+lang);
	}
	gate_url = gate_urls[gate_url_index];
}

function shutdown(data, reason) {
	// When the application is shutting down we normally don't have to clean
	// up any UI changes made
	if (reason == APP_SHUTDOWN)
		return;

	let wm = Cc["@mozilla.org/appshell/window-mediator;1"].
		getService(Ci.nsIWindowMediator);

	// Get the list of browser windows already open
	let windows = wm.getEnumerator("navigator:browser");
	while (windows.hasMoreElements()) {
		let domWindow = windows.getNext().QueryInterface(Ci.nsIDOMWindow);
		uninstall_window(domWindow);
	}

	// Stop listening for any new browser windows to open
	wm.removeListener(WindowListener);
	OBS.removeObserver(optionObserver, 'addon-options-displayed', false);
	global_uninstalled = true;
}

// region third party module
	/* ***** BEGIN LICENSE BLOCK *****
	* Version: MIT/X11 License
	*
	* Permission is hereby granted, free of charge, to any person obtaining a copy
	* of this software and associated documentation files (the "Software"), to deal
	* in the Software without restriction, including without limitation the rights
	* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	* copies of the Software, and to permit persons to whom the Software is
	* furnished to do so, subject to the following conditions:
	*
	* The above copyright notice and this permission notice shall be included in
	* all copies or substantial portions of the Software.
	*
	* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	* THE SOFTWARE.
	*
	* Contributor(s):
	* Dmitry Gutov <dgutov@yandex.ru> (Original Author)
	* Erik Vold <erikvvold@gmail.com>
	*
	* ***** END LICENSE BLOCK ***** */

	(function(global) {
		let positions = {};
		
		/*
		* Assigns position that will be used by `restorePosition`
		* if the button is not found on any toolbar's current set.
		* If `beforeID` is null, or no such item is found on the toolbar,
		* the button will be added to the end.
		* @param beforeID ID of the element before which the button will be inserted.
		*/
		global.setDefaultPosition = function(buttonID, toolbarID, beforeID) {
		positions[buttonID] = [toolbarID, beforeID];
		};
		
		/*
		* Restores the button's saved position.
		* @param {XULDocument} doc XUL window document.
		* @param {XULElement} button button element.
		*/
		global.restorePosition = function(doc, button) {
		function $(sel, all)
			doc[all ? "querySelectorAll" : "getElementById"](sel);
		
		($("navigator-toolbox") || $("mail-toolbox")).palette.appendChild(button);
		
		let toolbar, currentset, idx,
			toolbars = $("toolbar", true);
		for (let i = 0; i < toolbars.length; ++i) {
			let tb = toolbars[i];
			currentset = getCurrentset(tb),
			idx = currentset.indexOf(button.id);
			if (idx != -1) {
			toolbar = tb;
			break;
			}
		}
		
		// saved position not found, using the default one, if any
		if (!toolbar && (button.id in positions)) {
			let [tbID, beforeID] = positions[button.id];
			toolbar = $(tbID);
			[currentset, idx] = persist(doc, toolbar, button.id, beforeID);
		}
		
		if (toolbar) {
			if (idx != -1) {
			// inserting the button before the first item in `currentset`
			// after `idx` that is present in the document
			for (let i = idx + 1; i < currentset.length; ++i) {
				let before = $(currentset[i]);
				if (before) {
				toolbar.insertItem(button.id, before);
				return;
				}
			}
			}
			toolbar.insertItem(button.id);
		}
		};
		
		function persist(document, toolbar, buttonID, beforeID) {
		let currentset = getCurrentset(toolbar),
			idx = (beforeID && currentset.indexOf(beforeID)) || -1;
		if (idx != -1) {
			currentset.splice(idx, 0, buttonID);
		} else {
			currentset.push(buttonID);
		}
		toolbar.setAttribute("currentset", currentset.join(","));
		document.persist(toolbar.id, "currentset");
		return [currentset, idx];
		}

		function getCurrentset(toolbar) {
		return (toolbar.getAttribute("currentset") ||
				toolbar.getAttribute("defaultset")).split(",");
		}
	})(this);
// endregion third party module

// ******************************************************************************************************************************************************* //
function global_rumola(_win) {
	var win = _win;

	function rumola_form_ready_image(i_field) {
		// private
		this._i_field = i_field;
		this._asap = false;
		this._image_content = null;
		this._my_i_field = null;

		// public
		this.get_image_content = function() {
			this._asap = true;
			return this._image_content;
		}

		this.set_solving_icon = function() {
			if (!this._i_field) // class already died
				return; 
			if (!this._my_i_field) { // still not ready
				win.setTimeout(function (_this) {_this.set_solving_icon();}, 45, this);
				return;
			}
			this._my_i_field.style.setProperty("background-image", 'url("chrome://rumola/content/eye_r32x16.gif")', "important");
		}

		this.suicide = function() {
			if (this._my_i_field) {
				if (this._my_i_field.parentNode)
					this._my_i_field.parentNode.removeChild(this._my_i_field);
				this._i_field.style.removeProperty("display");
				this._i_field.style.setProperty("display", this._i_field_display_style.value, this._i_field_display_style.important);
			}
			var x = this._i_field;
			this._i_field = null;
			this._my_i_field = null;
			return x;
		}

		// private
		this._image_grabbed = function(image_src, image_src_transparent, width, height) {
			this._image_content = image_src;

			this._my_i_field = win.document.createElement("img");
			this._my_i_field.style.cssText = win.getComputedStyle(this._i_field, null).cssText;
			// TODO: copy other fields like title e.t.c.
			this._my_i_field.style.setProperty("background-image", 'url("chrome://rumola/content/eye_w32x16.gif")', "important");
			this._my_i_field.style.setProperty("background-repeat", "no-repeat", "important");
			this._my_i_field.style.setProperty("background-position", "0px 0px", "important");
			this._my_i_field.src = image_src_transparent;
			this._i_field_display_style = {important:this._i_field.style.getPropertyPriority("display"), value:this._i_field.style.removeProperty("display")};
			this._i_field.style.setProperty("display", "none", "important");
			if (this._i_field.parentNode.lastchild == this._i_field)
				this._i_field.parentNode.append(this._my_i_field);
			else
				this._i_field.parentNode.insertBefore(this._my_i_field, this._i_field.nextSibling);
		}

		this._try_capture_snapshot = function() {
			if (!this._i_field) // class already died
				return;

			var prev_style = null;
			prev_style = this._save_post_and_move_image();

			var _this = this;
			win.setTimeout(function() {
				var pos = _this._i_field.getBoundingClientRect();
				var _canvas = win.document.createElement("canvas");
				_canvas.width = pos.width;
				_canvas.height = pos.height;
				var _ctx = _canvas.getContext("2d");

				_ctx.drawWindow(_this._i_field.ownerDocument.defaultView, pos.x, pos.y, _canvas.width, _canvas.height, 'rgb(255, 255, 255)');
				var tmp = _canvas.toDataURL("image/png");

				_this._restore_image_pos(prev_style);

				var __canvas = win.document.createElement("canvas");
				__canvas.width = pos.width;
				__canvas.height = pos.height;
				var __ctx = __canvas.getContext("2d");
				__ctx.globalAlpha = 0.2;
				__ctx.drawImage(_canvas, 0, 0, __canvas.width, __canvas.height);
				var tmp_transparent = __canvas.toDataURL("image/png");

				_this._image_grabbed(tmp, tmp_transparent, _this._i_field.width, _this._i_field.height);
			}, 50);
		}

		this._save_post_and_move_image = function() {
			// TODO: if it have any transparency, i need to put some image to background
			var prev_style = {dimportant:this._i_field.style.getPropertyPriority("display"), dvalue:this._i_field.style.getPropertyValue("display"),
				pimportant:this._i_field.style.getPropertyPriority("position"), pvalue:this._i_field.style.getPropertyValue("position"),
				limportant:this._i_field.style.getPropertyPriority("left"), lvalue:this._i_field.style.getPropertyValue("left"),
				timportant:this._i_field.style.getPropertyPriority("top"), tvalue:this._i_field.style.getPropertyValue("top"),
				zimportant:this._i_field.style.getPropertyPriority("z-index"), zvalue:this._i_field.style.getPropertyValue("z-index")};
			this._i_field.style.setProperty("display", "block", "important");
			this._i_field.style.setProperty("position", "absolute", "important");
			this._i_field.style.setProperty("left", "0px", "important");
			this._i_field.style.setProperty("top", "0px", "important");
			this._i_field.style.setProperty("z-index", "9223372036854776000", "important");
			return prev_style;
		}

		this._restore_image_pos = function(prev_style) {
			this._i_field.style.removeProperty("display");
			this._i_field.style.removeProperty("position");
			this._i_field.style.removeProperty("left");
			this._i_field.style.removeProperty("top");
			this._i_field.style.setProperty("display", prev_style.dvalue, prev_style.dimportant);
			this._i_field.style.setProperty("position", prev_style.pvalue, prev_style.pimportant);
			this._i_field.style.setProperty("left", prev_style.lvalue, prev_style.limportant);
			this._i_field.style.setProperty("top", prev_style.tvalue, prev_style.timportant);
			this._i_field.style.setProperty("z-index", prev_style.zvalue, prev_style.zimportant);
		}

		this._try_capture_direct = function() {
			if (!this._i_field) // class already died
				return;

			if (this._i_field.tagName == 'IMG') {
				if (!this._i_field.complete || (rumola_notifications.notifying_counter > 0)) {
					win.setTimeout(function (_this) {_this._try_capture_direct();}, 45, this);
					return;
				}

				try {
					var _canvas = win.document.createElement("canvas");
					_canvas.width = this._i_field.width;
					_canvas.height = this._i_field.height;
					var _ctx = _canvas.getContext("2d");

					_ctx.globalAlpha = 0.2;
					_ctx.drawImage(this._i_field, 0, 0, _canvas.width, _canvas.height);
					var tmp_transparent = _canvas.toDataURL("image/png");

					_ctx.globalAlpha = 1;
					_ctx.drawImage(this._i_field, 0, 0, _canvas.width, _canvas.height);
					var tmp = _canvas.toDataURL("image/png");

					this._image_grabbed(tmp, tmp_transparent, this._i_field.width, this._i_field.height);
					return;
				} catch (secexc) {
					// it's impossible for FF)
				}
				this._try_capture_snapshot();
				return;
			}
			this._try_capture_snapshot();
		}
		this._try_capture_direct();
	}

	function rumola_form_ready_input(t_field, dblclick_listener) {
		// private
		this._t_field = t_field;

		// public
		this.change_input_field = function(t_field) {
			if (this._dblclick_listener)
				this._t_field.removeEventListener("dblclick", this._dblclick_listener, true);
			var x = this._icon_url;
			this._visual_cancel();
			if ((this._t_field_previous_value !== null)&&(this._t_field.value == this._solution)) {
				this._t_field.value = this._t_field_previous_value;
			}
			this._t_field_previous_value = null;

			this._t_field = t_field;

			this._icon_url = x;
			if (this._icon_url)
				this._update_icon();
			if (this._dblclick_listener)
				this._t_field.addEventListener("dblclick", this._dblclick_listener, true);
			if (this._solution) {
				this.set_value(this._solution);
			}
		}

		this.set_solving_icon = function() {
			if (this._icon_url) {
				this._icon_url = 'url("chrome://rumola/content/pen_r.gif")';
				this._update_icon();
			}
			if (this._dblclick_listener) {
				this._t_field.removeEventListener("dblclick", this._dblclick_listener, true);
				this._dblclick_listener = null;
			}
		}

		this._solution = null;
		this._t_field_previous_value = null;
		this.set_value = function(v) {
			if (this._t_field_previous_value == null)
				this._t_field_previous_value = this._t_field.value;
			this._t_field.value = v;
			this._solution = v;
			this._visual_cancel();
		}

		this.suicide = function() {
			this._visual_cancel();
			if (this._dblclick_listener) {
				this._t_field.removeEventListener("dblclick", this._dblclick_listener, true);
				this._dblclick_listener = null;
			}
			this._t_field = null;
		}

		// private
		this._dblclick_listener = dblclick_listener;
		this._t_field.addEventListener("dblclick", dblclick_listener, true);

		this._icon_url = 'url("chrome://rumola/content/pen_w.gif")';
		this._t_field_style = null;
		this._update_icon = function() {
			if (!this._t_field_style) {
				this._t_field_style = {bi_important:this._t_field.style.getPropertyPriority("background-image"), bi_value:this._t_field.style.removeProperty("background-image"),
						br_important:this._t_field.style.getPropertyPriority("background-repeat"), br_value:this._t_field.style.removeProperty("background-repeat"),
						bp_important:this._t_field.style.getPropertyPriority("background-position"), bp_value:this._t_field.style.removeProperty("background-position")};
			}
			this._t_field.style.setProperty("background-image", this._icon_url, "important");
			this._t_field.style.setProperty("background-repeat", "no-repeat", "important");
			this._t_field.style.setProperty("background-position", "0px 0px", "important");
		}
		this._update_icon();

		this._visual_cancel = function() {
			if (this._t_field_style) {
				this._t_field.style.removeProperty("background-image");
				this._t_field.style.removeProperty("background-repeat");
				this._t_field.style.removeProperty("background-position");
				this._t_field.style.setProperty("background-image", this._t_field_style.bi_value, this._t_field_style.bi_important);
				this._t_field.style.setProperty("background-repeat", this._t_field_style.br_value, this._t_field_style.br_important);
				this._t_field.style.setProperty("background-position", this._t_field_style.bp_value, this._t_field_style.bp_important);
				this._t_field_style = null;
				this._icon_url = null;
			}
		}
	}

	function rumola_document(default_search_enabled) {

		this.init = function(search_enabled) {
			this.my_forms = new Array();
			this.wait_events = new Array();
			this.max_form_id = 0;
			this.zero_form_tag = 0;
			this.load_fires = true;
			this.selected_i_field = null;
			this.selected_t_field = null;
			this.my_forms_array_type = search_enabled ? 0 : -1;
		}
		this.init(default_search_enabled);

		// add this event listeners recurently for all the frames
		try
		{
			initDocumentEventListener(win, "load", rumola.document_load_fires, true); // to catch loading images or frames

			initDocumentEventListener(win, "keypress", rumola.document_changed, false); // to start/stop solve, cancel Rumola
			initDocumentEventListener(win, "change", rumola.document_changed, false); // to start/stop solve, cancel Rumola
			initDocumentEventListener(win, "submit", rumola.vfs_submit, true); // catching captcha forms submition
			initDocumentEventListener(win, "click", rumola.vfs_click, true); // catching captcha forms submition

			initDocumentEventListener(win, "dragstart", ip_class.dragevent, true);
			initDocumentEventListener(win, "dragenter", ip_class.dropevent, true);
		}
		catch (exc) {rumola_notifications.send_exception(1309, exc);}

		this.apply_idle_mode = function() { // idle is -1
			this._suicide_forms();
			this.init(false);
			rumola_prefs.new_frame_id();
		}

		this.start_solve = function(form_id) {
			if (form_id != 0) {
				var x = this.my_forms[0];
				this.my_forms[0] = this.my_forms[form_id];
				this.my_forms[form_id] = x;
			}
			this.leave_only_zero_form();

			this.my_forms[0].start_solve();
		}

		this.apply_simple_mode_and_leave_form = function(form_id) { // simple mode == 1
			//
		}

		this.leave_only_zero_form = function() {
			this._suicide_forms_except_one(0);
			this.my_forms_array_type = 1;
		}

		this.apply_simple_mode = function(selected_i_field, selected_t_field) { // simple mode == 1
			this.apply_idle_mode();
			this.my_forms_array_type = 1;
			this.selected_t_field = selected_t_field;
			this.selected_i_field = selected_i_field;

			if (this.selected_t_field && this.selected_i_field) {
				var objects = new Array();
				objects[0] = this.selected_i_field;
				objects[1] = this.selected_t_field;
				var line = "||C:b05911b84d9||F:b05911b84d9";
				this.my_forms[0] = new rumola_form_wait(null, objects, line, 0);
				var toGate = "-1||0" + line;
			} else {
				var ttt_struct = full_process_page(1, 9999999);
				this.my_forms[0] = new rumola_form_wait(null, ttt_struct.objects[0], ttt_struct.lines[0], 0);
				var toGate = "-1||0" + ttt_struct.lines[0];
			}

			if (this.selected_t_field && !toGate.match(/\|\|[F]:/))
				return;
			if (this.selected_i_field && !toGate.match(/\|\|[C]:/))
				return;

			if (toGate.match(/\|\|[TF]:/) && toGate.match(/\|\|[ICOWRD]:/)) {
				send_request_to_first_gate(toGate, win, rumola.frame_id, 1);
			}
		}

		// private
		this._suicide_forms_except_one = function(j) {
			for (var i=0; i<this.my_forms.length; i++) {
				if ((this.my_forms[i])&&(i!=j)) {
					this.my_forms[i].suicide();
					this.my_forms[i] = null;
				}
			}
		}

		this._suicide_forms = function() {
			this._suicide_forms_except_one(-1);
		}
	}

	function rumola_form_wait(my_form, objects, line, shift) { // for zero form shift is unique id
		this.my_form = my_form;
		this.important_elements = objects;
		this.form_hash = hashCode(line);
		this.shift = shift;

		this.suicide = function() {
			this.my_form = null;
			for (var i=0; i<this.important_elements.length; i++) {
				this.important_elements[i] = null;
			}
		}
	}

	function rumola_form_ready(my_form, t_field, i_field, captcha_id, b_gate_url) {
		this.my_form = my_form;
		this.captcha_id = captcha_id;
		this.b_gate_url = b_gate_url;
		this.solving_type = 0;

		this._ondblclick = function(evt) {
			// "this" is a input field
			for (var i=0; i<rumola.document.my_forms.length; i++)
				if ((rumola.document.my_forms[i] instanceof rumola_form_ready)&&(rumola.document.my_forms[i].is_captcha_input(evt.target))) {
					rumola.document.start_solve(i);
					return;
				}
		}
		this.start_solve = function() {
			if (this.solving_type != 0)
				return;

			this.solving_type = 1;
			this.i_field.set_solving_icon();
			this.t_field.set_solving_icon();
			this._send_image_to_gate();
		}

		this.t_field = new rumola_form_ready_input(t_field, this._ondblclick);
		this.i_field = new rumola_form_ready_image(i_field);

		this.i_field_reloaded = function() {
			this.i_field = new rumola_form_ready_image(this.i_field.suicide());
		}

		this.is_captcha_image = function(target, bIncludeBothImages) {
			if (this.i_field._i_field == target)
				return true;
			if (!this.i_field._i_field)
				return false;
			if (this.i_field._i_field.contains(target))
				return true;
			if (!bIncludeBothImages)
				return false;
			if (this.i_field._my_i_field == target)
				return true;
			return false;
		}

		this.is_captcha_input = function(target) {
			if (this.t_field._t_field == target)
				return true;
			return false;
		}

		this.is_my_form = function(f) {
			if (this.t_field._t_field.form == f)
				return true;
			return false;
		}

		this.change_t_field = function(t_field) {
			this.t_field.change_input_field(t_field);
		}

		this.get_t_position = function() {
			return this.t_field._t_field.getBoundingClientRect();
		}

		this.set_t_value = function(s) {
			this.t_field.set_value(s);
			this.solving_type++;
		}

		this.operation_id = 1;

		this.suicide = function() {
			this.t_field.suicide();
			this.t_field = null;
			this.i_field.suicide();
			this.i_field = null;
			this.captcha_id = null;
		}

		this._send_image_to_gate = function() {
			if (!this.captcha_id)
				return;

			var img = this.i_field.get_image_content();
			if (!img) {
				var _this = this;
				win.setTimeout(function (_this) {_this._send_image_to_gate();}, 250, _this);
				return;
			}

			img = img.replace(/^data:image\/png;base64,/, "");
			send_request_to_second_gate(win, {frame_id: rumola.frame_id, method:"POST", url:this.b_gate_url+this.captcha_id+"&f=0", data:img});
			voice_notification("notifications/start.wav");
		}
	}

	var wait_box = {
		div: null,
		domain: "",

		create_wait_div: function() {
			if (wait_box.div)
				return false;

			// TODO: fix it
			if (win.document.body instanceof win.HTMLFrameSetElement)
				return false;

			if (!win.document.getElementById("B7EA4724019B")) {
				var ss = win.document.createElement("link");
				ss.setAttribute("rel", "stylesheet");
				ss.setAttribute("type", "text/css");
				ss.setAttribute("id", "B7EA4724019B");
				ss.setAttribute("href", "chrome://rumola/content/style.css");
				win.document.getElementsByTagName("head")[0].appendChild(ss);
			}

			wait_box.domain = autosolve_get_domain(win.document.domain);
			var f_checked = true;
			if (!wait_box.domain) {
				f_checked = false;
				wait_box.domain = win.document.domain;
			}
			wait_box.div = win.document.createElement('div');
			wait_box.div.setAttribute("id", "B2C54724019B");
			wait_box.div.setAttribute("className", "B8C34724019B");
			wait_box.div.innerHTML = '<div class="BCC34724019B" id="A5D44724019B"></div><div class="C3C34724019B"><div class="AF8A4824019B" style="clear: both; margin: 30px 30px;"><span class="C4C34724019B" id="E6D44724019B"></span><fieldset><div class="DDBD4724019B"><img src="chrome://rumola/content/wait.png" alt=""/></div><div class="C5C34724019B"><img src="chrome://rumola/content/loader.gif" alt=""/></div><div class="B627BBE59B18"><img id="AF976188709B" style="cursor:pointer" title="Click to switch"/></div><div class="CBC34724019B"><input type="button" value="Cancel" id="F8D54724019B"/></div><div class="CBC34724019B"><br/><input id="E4FE60BE6F" type="checkbox"> Activate automated captchas recognition for <span id="fd19dd671788"></span></div></fieldset></div></div></div>';
			wait_box.div.childNodes[1].childNodes[0].childNodes[1].childNodes[2].childNodes[0].src = 'chrome://rumola/content/switcher_'+get_switcher_position()+'.png';
			wait_box.div.childNodes[1].childNodes[0].childNodes[1].childNodes[4].childNodes[1].checked = f_checked;
			wait_box.div.childNodes[1].childNodes[0].childNodes[1].childNodes[4].childNodes[3].textContent = wait_box.domain;
			win.document.body.appendChild(wait_box.div);
			wait_box.div.addEventListener("click", wait_box._click, true);
			return true;
		},

		hide_wait_div: function() {
			if (!wait_box.div)
				return false;

			win.document.body.removeChild(wait_box.div);
			wait_box.div.removeEventListener("click", wait_box._click, true);
			wait_box.div = null;
			return true;
		},

		_click: function(e) {
			if (e.target.id != 'E4FE60BE6F') {
				e.preventDefault();
				e.stopPropagation();
			}
			switch (e.target.id) {
				case "AF976188709B": // switcher
					var src = e.target.src;
					var p = src.length-5;
					var v = (src.charAt(p) == 'q') ? 'p' : 'q';
					e.target.src = src.substr(0, p) + v + src.substr(p+1);
					var v = set_switcher_position(v);
					break;
				case "E6D44724019B": // X
				case "F8D54724019B": // cancel
				case "A5D44724019B": // out of box area
					rumola.document.wait_events = null;
					wait_box.hide_wait_div();
					break;
				case "E4FE60BE6F":
					if (e.target.checked)
						autosolve_add_domain(wait_box.domain);
					else
						autosolve_remove_domain(wait_box.domain);
					break;
			}
		}
	}

	var ip_class = {
		dropevent: function(e) {
		try
		{
			var el = e.target;
			if (el.tagName != 'INPUT')
				return;
			if (!acceptable_input_type(el.type, true))
				return;
			if (!rumola_prefs.last_dragged_element)
				return;
			if ((rumola_prefs.last_dragged_element.tagName != 'IMG')&&(rumola_prefs.last_dragged_element.tagName != 'A'))
				return;

			var u = 'url("chrome://rumola/content/pen_w.gif")';
			var t_field_style = {bi_important:el.style.getPropertyPriority("background-image"), bi_value:el.style.removeProperty("background-image"),
				br_important:el.style.getPropertyPriority("background-repeat"), br_value:el.style.removeProperty("background-repeat")};
			el.style.setProperty("background-image", u, "important");
			el.style.setProperty("background-repeat", "no-repeat", "important");

			var drope = null;
			var dragl = function(e) {
				el.style.removeProperty("background-image");
				el.style.setProperty("background-image", t_field_style.bi_value, t_field_style.bi_important);
				el.style.removeProperty("background-repeat");
				el.style.setProperty("background-repeat", t_field_style.br_value, t_field_style.br_important);
				el.removeEventListener("dragleave", dragl, true);
				el.removeEventListener("drop", drope, true);
			}
			el.addEventListener("dragexit", dragl, true);

			drope = function(e) {
			try
			{
				el.removeEventListener("drop", drope, true);
				e.stopPropagation();
				e.preventDefault();
				dragl(e);
				for (var i=0; i<rumola.document.my_forms.length; i++) {
					if ((rumola.document.my_forms[i] instanceof rumola_form_ready)&&(rumola.document.my_forms[i].is_captcha_image(rumola_prefs.last_dragged_element, true))) {
						if (!rumola.document.my_forms[i].is_captcha_input(e.target))
							rumola.document.my_forms[i].change_t_field(e.target);
						rumola.document.start_solve(i);
						return;
					}
				}
				rumola.document.apply_simple_mode(rumola_prefs.last_dragged_element, e.target);
			}
			catch (exc) {rumola_notifications.send_exception(1133, exc);}
			}
			el.addEventListener("drop", drope, true);
		}
		catch (exc) {rumola_notifications.send_exception(1215, exc);}
		},

		dragevent: function(event) {
			var element = event.target;
			rumola_prefs.last_dragged_element = element;
		}
	}

	var rumola = {
		frame_id: null,
		last_changed_element: null,

		document_load_fires: function (aEvent) {
		try
		{
			if (aEvent.target && aEvent.target.ownerDocument && aEvent.target.ownerDocument.defaultView &&
				((aEvent.target instanceof aEvent.target.ownerDocument.defaultView.HTMLIFrameElement)||(aEvent.target instanceof aEvent.target.ownerDocument.defaultView.HTMLFrameElement))) {
				initDocumentEventListener(aEvent.target.contentWindow, "load", rumola.document_load_fires, true);

				initDocumentEventListener(aEvent.target.contentWindow, "keypress", rumola.document_changed, false);
				initDocumentEventListener(aEvent.target.contentWindow, "change", rumola.document_changed, false);
				initDocumentEventListener(aEvent.target.contentWindow, "submit", rumola.vfs_submit, true);
				initDocumentEventListener(aEvent.target.contentWindow, "click", rumola.vfs_click, true);

				initDocumentEventListener(aEvent.target.contentWindow, "dragstart", ip_class.dragevent, true);
				initDocumentEventListener(aEvent.target.contentWindow, "dragenter", ip_class.dropevent, true);
				rumola.document.load_fires = true; // can appear anything
				return;
			}

			if (!aEvent.target.ownerDocument.defaultView instanceof win.HTMLImageElement)
				return;

			for (var i=0; i<rumola.document.my_forms.length; i++) {
				if ((rumola.document.my_forms[i] instanceof rumola_form_ready)&&(rumola.document.my_forms[i].solving_type == 0)&&(rumola.document.my_forms[i].is_captcha_image(aEvent.target, false))) {
					rumola.document.my_forms[i].i_field_reloaded();
					return;
				}
			}

			rumola.document.load_fires = true;
		}
		catch (exc) {rumola_notifications.send_exception(1531, exc);}
		},

	// *****************************************************************************************

		document_changed: function (aEvent) {
		try
		{
			if (aEvent.target == rumola.last_changed_element)
				return;
			rumola.last_changed_element = aEvent.target;

			if ((aEvent.keyCode == 9)||(aEvent.keyCode == 13))
				return;

			if (rumola.document.my_forms_array_type == -1)
				return;

			for (var i=0; i<rumola.document.my_forms.length; i++) {
				if (rumola.document.my_forms[i] instanceof rumola_form_ready) {
					if ((rumola.document.my_forms[i].solving_type < 3)&&(rumola.document.my_forms[i].is_captcha_input(aEvent.target))) {
						voice_notification("notifications/cancelled.wav");
						rumola.document.apply_idle_mode();
						return;
					}
					if ((rumola.document.my_forms[i].solving_type == 0)&&(rumola.document.my_forms[i].is_my_form(aEvent.target.form))) {
						rumola.document.start_solve(i);
						return;
					}
				}
			}
		}
		catch (exc) {rumola_notifications.send_exception(1205, exc);}
		},

		vfs_submit: function(aEvent) {
		try
		{
			if (rumola.document.wait_events === null)
				return;

			if (rumola.document.my_forms_array_type == -1)
				return;

			var f = aEvent.target;
			var k = null;
			for (var i=0; i<rumola.document.my_forms.length; i++) {
				if ((rumola.document.my_forms[i] instanceof rumola_form_ready)&&(rumola.document.my_forms[i].is_my_form(f))) {
					k = i;
					break;
				}
			}
			if (k == null)
				return;

			if (rumola.document.my_forms[0].solving_type > 1)
				return;

			if (rumola.document.my_forms[k].solving_type == 0)
				rumola.document.start_solve(k);

			wait_box.create_wait_div();
			aEvent.preventDefault();
			aEvent.stopPropagation();

			var evt = win.document.createEvent("HTMLEvents");
			evt.initEvent(aEvent.type, aEvent.bubbles, aEvent.cancelable);
			rumola.document.wait_events.push({evt:evt,target:aEvent.originalTarget});
		}
		catch (exc) {rumola_notifications.send_exception(1609, exc);}
		},

		vfs_click: function(aEvent) {
		try
		{
			if (rumola.document.wait_events === null)
				return;

			if (rumola.document.my_forms_array_type == -1)
				return;

			if (aEvent.button != 0)
				return;

			if (aEvent.target.id == 'A5D44724019B' || aEvent.target.id == 'E6D44724019B' || aEvent.target.id == 'F8D54724019B' || aEvent.target.id == 'AF976188709B' || aEvent.target.id == 'E4FE60BE6F')
				return;

			var bGood = ((aEvent.target.tagName == 'INPUT')&&
				((aEvent.target.type == 'button')||(aEvent.target.type == 'image')||(aEvent.target.type == 'submit')));
			bGood = bGood || (aEvent.target.tagName == 'BUTTON');
			if (!bGood) {
				bGood = (aEvent.target instanceof win.Element) && (aEvent.target.ownerDocument.defaultView.getComputedStyle(aEvent.target, null).getPropertyValue("cursor") == 'pointer');
			}
			if (!bGood)
				return;

			if (rumola.document.my_forms_array_type == 0) {
				var pos = aEvent.target.getBoundingClientRect();
				var ww = Math.max(windowWidth(win)*0.33, 250);
				for (var i=0; i<rumola.document.my_forms.length; i++) {
					if (rumola.document.my_forms[i] instanceof rumola_form_ready) {
						var pos1 = rumola.document.my_forms[i].get_t_position();
						if ((Math.abs(pos1.bottom-pos.top) < 150)&&(Math.abs(pos1.left-pos.left) < ww)) {
							rumola.document.start_solve(i);
							break;
						}
					}
				}
			}

			if ((rumola.document.my_forms_array_type == 1)&&(rumola.document.my_forms[0] instanceof rumola_form_ready)&&(rumola.document.my_forms[0].solving_type == 1)) {
				wait_box.create_wait_div();
				aEvent.preventDefault();
				aEvent.stopPropagation();

				var evt = win.document.createEvent("MouseEvent");
				evt.initMouseEvent(aEvent.type, aEvent.bubbles, aEvent.cancelable, aEvent.view, aEvent.detail, 
							aEvent.screenX, aEvent.screenY, aEvent.clientX, aEvent.clientY, 
							aEvent.ctrlKey, aEvent.altKey, aEvent.shiftKey, aEvent.metaKey, aEvent.button, aEvent.relatedTarget);
				rumola.document.wait_events.push({evt:evt,target:aEvent.target});
			}
		}
		catch (exc) {rumola_notifications.send_exception(1603, exc);}
		},

	// *****************************************************************************************

		process_document: function () {
			try {
				if (rumola.document.my_forms_array_type == 0) {
					var toGate = "";
					if (rumola.document.load_fires) { // TODO: think about it - only if load_fires it can be any changes?
						for (var k = 1; k <= rumola.document.max_form_id; k++) {
							// https://developer.mozilla.org/en-US/docs/Web/API/Node.contains
							if ((rumola.document.my_forms[k] instanceof rumola_form_ready)&&
								((!rumola.document.my_forms[k].i_field._i_field.ownerDocument)||
								(!rumola.document.my_forms[k].i_field._i_field.ownerDocument.body)||
								(!rumola.document.my_forms[k].i_field._i_field.ownerDocument.body.contains(rumola.document.my_forms[k].i_field._i_field)))) {
								rumola.document.my_forms[k].suicide();
								rumola.document.my_forms[k] = null;
							}
						}

						// TODO: stop if total number of forms will be big
						var ttt_struct = full_process_page(0, 20000);

						// TODO: may be i need to save local_max_form_id before full_process_page and use it not in all parts of code?
						var local_max_form_id = rumola.document.max_form_id;
						var have_changes = false;
						for (var k = 1; k <= local_max_form_id; k++) {
							if (!rumola.document.my_forms[k] && !ttt_struct.forms[k])
								continue;
							if (!rumola.document.my_forms[k] || !ttt_struct.forms[k]) {
								have_changes = true;
								break;
							}
							if (rumola.document.my_forms[k] instanceof rumola_form_ready)
								continue;
							if (rumola.document.my_forms[k].form_hash != hashCode(ttt_struct.lines[k])) {
								have_changes = true;
								break;
							}
						}

						var have_ready_forms = false;
						for (var k = 1; k <= local_max_form_id; k++) {
							if (rumola.document.my_forms[k] instanceof rumola_form_ready) {
								have_ready_forms = true;
								break;
							}
						}

						if (!have_ready_forms && !have_changes) {
							if (!rumola.document.my_forms[0] || (rumola.document.my_forms[0].form_hash != hashCode(ttt_struct.lines[0])))
								have_changes = true;
						}

						if (have_changes) {
							// TODO: if have_ready_forms then each form must have ICOWRD and TF
							if (!have_ready_forms) {
									if (rumola.document.my_forms[0])
										rumola.document.my_forms[0].suicide();
									rumola.document.my_forms[0] = new rumola_form_wait(null, ttt_struct.objects[0], ttt_struct.lines[0], 0);
									toGate = toGate + get_zero_from_tag() + "||0" + ttt_struct.lines[0] + "\n";
							}
							for (var k = 1; k <= local_max_form_id; k++) {
								if (!rumola.document.my_forms[k] && !ttt_struct.forms[k])
									continue;
								if (rumola.document.my_forms[k] && !ttt_struct.forms[k]) {
									rumola.document.my_forms[k].suicide();
									rumola.document.my_forms[k] = null;
									continue;
								}
								if (!rumola.document.my_forms[k] && ttt_struct.forms[k]) {
									rumola.document.my_forms[k] = new rumola_form_wait(ttt_struct.forms[k], ttt_struct.objects[k], ttt_struct.lines[k], ttt_struct.shifts[k]);
									toGate = toGate + ttt_struct.shifts[k] + "||" + k + ttt_struct.lines[k] + "\n";
									continue;
								}
								if (rumola.document.my_forms[k] instanceof rumola_form_ready)
									continue;
								if (!have_ready_forms || (rumola.document.my_forms[k].form_hash != hashCode(ttt_struct.lines[k]))) {
									rumola.document.my_forms[k].suicide();
									rumola.document.my_forms[k] = null;

									var f = newFormId(ttt_struct.forms[k]);
									rumola.document.my_forms[f] = new rumola_form_wait(ttt_struct.forms[k], ttt_struct.objects[k], ttt_struct.lines[k], ttt_struct.shifts[k]);
									toGate = toGate + ttt_struct.shifts[k] + "||" + f + ttt_struct.lines[k] + "\n";

									continue;
								}
							}
							// TODO: if have_ready_forms i need to make this checks for every form
							if (!toGate.match(/\|\|[TF]:/) || !toGate.match(/\|\|[ICOWRD]:/) || (!ttt_struct.have_good_fields)) {
								toGate = "";
							}
						}
					}
					rumola.document.load_fires = false;
					if (toGate) {
						send_request_to_first_gate(toGate, win, rumola.frame_id, 1);
					}
				}
			} catch (exc) {
				rumola_notifications.send_exception(1208, exc);
			}
			if (rumola.document.my_forms_array_type == 0)
				win.setTimeout(rumola.process_document, 450);
		},

		document_load: function(pd) {
			if (!win.document instanceof win.HTMLDocument)
				return;

			if ((""+win.document.domain).match(/(rumola\.com|skipinput\.com)$/)) {
				var e = win.document.getElementById("9C6079EE-41B2-11E1-989C-B9874824019B");
				if (e) e.setAttribute("style", "display:none");

				var e = win.document.getElementById("A62533E4-285A-11E3-A009-36756188709B");
				if (e) e.style.removeProperty("display");

				var e = win.document.getElementById("AB3BD3FA-285B-11E3-ADDA-16766181709B");
				if (e) {
					activate_and_callback(function() {
						win.setTimeout(function() {var s = "quick_login('"+get_rumola_key1()+"', "+get_rumola_key2_sum()+");";win.eval(s);}, 0);
					});
				}
			}
			rumola.document = new rumola_document(pd);
			if (pd)
				rumola.process_document();
		},

		i_selected: function(i_field) {
			for (var i=0; i<rumola.document.my_forms.length; i++) {
				if ((rumola.document.my_forms[i] instanceof rumola_form_ready)&&(rumola.document.my_forms[i].is_captcha_image(i_field, true))) {
					if (rumola.document.my_forms[i].solving_type == 0)
						rumola.document.start_solve(i);
					return;
				}
			}
			rumola.document.apply_simple_mode(i_field, rumola.document.selected_t_field);
			rumola_notifications.notify_manual_selecting(i_field, true);
		},

		t_selected: function(t_field) {
			for (var i=0; i<rumola.document.my_forms.length; i++) {
				if ((rumola.document.my_forms[i] instanceof rumola_form_ready)&&(rumola.document.my_forms[i].is_captcha_input(t_field))) {
					if (rumola.document.my_forms[i].solving_type == 0)
						rumola.document.start_solve(i);
					return;
				}
			}

			if ((rumola.document.my_forms_array_type == 1)&&(rumola.document.my_forms[0] instanceof rumola_form_ready)&&(rumola.document.my_forms[0].solving_type > 0)) {
				rumola.document.selected_t_field = t_field;
				rumola.document.my_forms[0].change_t_field(t_field);
				return;
			}

			rumola.document.apply_simple_mode(rumola.document.selected_i_field, t_field);
			rumola_notifications.notify_manual_selecting(t_field, false);
		},

		process_document_by_request: function(selected_i_field, selected_t_filed) {
			rumola.document.apply_simple_mode(null, null);
		},

		// *****************************************************************************************

		response_from_first_gate: function(tags, b_gate_url) {
			rumola.last_changed_element = null;

			var retval = false;
			for (var i=5; i<tags.length; i+=5)
			{
				if (!(rumola.document.my_forms[tags[i-3]] instanceof rumola_form_wait))
					continue;

				if (tags[i-3] == 0) {
					if ((rumola.document.my_forms_array_type == 0)&&(rumola.document.zero_form_tag != tags[i-4]))
						return false;

					rumola.document.leave_only_zero_form();
				}

				rumola_prefs.last_found_captcha_id = tags[i-3];
				var tmp = new rumola_form_ready(rumola.document.my_forms[tags[i-3]].my_form,
					rumola.document.my_forms[tags[i-3]].important_elements[tags[i-2]],
					rumola.document.my_forms[tags[i-3]].important_elements[tags[i-1]],
					tags[i], b_gate_url);
				rumola.document.my_forms[tags[i-3]].suicide();
				rumola.document.my_forms[tags[i-3]] = tmp;
				if ((rumola.document.selected_i_field)||(autosolve_get_domain(win.document.domain)))
					rumola.document.start_solve(tags[i-3]);
				retval = true;
			}
			if ((retval)&&(!tags[0].match(/{{/)))
				voice_notification("notifications/found.wav");
			return retval;
		},

		response_from_second_gate: function(tags) {
			try
			{
				if (tags.length < 5)
					return false;
				if (!rumola.document.my_forms[0] instanceof rumola_form_ready)
					return false;

				switch (tags[3]) {
					case "ERR":
						wait_box.hide_wait_div();
						rumola.document.apply_idle_mode();
						change_rumola_gate_url(false, false);
						break;
					case "WAIT":
					case "TMP":
						var fid = rumola.frame_id;
						win.setTimeout(function() {
								if (rumola.frame_id != fid) {
									return;
								}
								send_request_to_second_gate(win, {frame_id: rumola.frame_id, method:"GET", data:null, url:rumola.document.my_forms[0].b_gate_url+rumola.document.my_forms[0].captcha_id});
							}, tags[4]);
						if (tags[3] == 'WAIT')
							break;
					case "OK":
						rumola.document.my_forms[0].set_t_value(tags[5]);
						if ((rumola.document.wait_events !== null)&&(rumola.document.wait_events.length > 0)&&((tags[3] == 'OK')||(rumola_prefs.switcher_position == 'q'))) {
							wait_box.hide_wait_div();
							win.setTimeout(function() {
								for (var i=0; i<rumola.document.wait_events.length; i++) {
									rumola.document.wait_events[i].target.dispatchEvent(rumola.document.wait_events[i].evt);
								}
								rumola.document.wait_events = null;
							}, 1);
						}
						if (tags[3] == 'TMP')
							break;
						if (!tags[0].match(/{{/)) {
							voice_notification("notifications/entered.wav");
						}
						rumola.document.my_forms[0].i_field.suicide();
				}
			}
			catch (exc) {rumola_notifications.send_exception(1006, exc);}
			return true;
		}

	}

	var rumola_prefs = {
		enabled: true,
		filters: Array(),
		last_dragged_element: null,
		
		new_frame_id: function() {
			rumola.frame_id = "::"+(new Date()).getTime()+"::"+Math.random();
		},

		on_request: function(req, obj) {
			switch (req) {
				case "context":
					if ((obj instanceof win.HTMLInputElement)&&(acceptable_input_type(obj, true)))
						rumola.t_selected(obj);
					if (obj instanceof win.HTMLImageElement)
						rumola.i_selected(obj);
					break;
				case "AutoSearch":
					rumola.process_document_by_request(null, null);
					break;
				case "Cancel":
					rumola.document.apply_idle_mode();
					break;
				case "ResponseFromFirstGate":
					if (rumola.frame_id != obj.frame_id)
						return false;
					return rumola.response_from_first_gate(obj.tags, obj.b_gate_url);
					break;
				case "ResponseFromSecondGate":
					if (rumola.frame_id != obj.frame_id)
						return false;
					return rumola.response_from_second_gate(obj.tags);
					break;
			}
		},

		init_prefs: function() {
			win.rumola_top_window_message = rumola_prefs.on_request;
			rumola_prefs.new_frame_id();
			rumola_prefs.enabled = get_rumola_enabled();
			var filter_strings = get_regexes_string().split("||");
			for (var i=0; i<filter_strings.length; i++)
				rumola_prefs.filters.push(new RegExp(filter_strings[i], "i"));
			rumola.document_load(rumola_prefs.enabled);
		}

	}

	var rumola_notifications = { // send_exception, notify_manual_selecting 
		last_exception_sent: 0,
		notifying_counter: 0,

		send_exception: function(from, exception) {
			/*
			var n = (new Date()).getTime();
			if (rumola_notifications.last_exception_sent + 150000 > n)
				return;
			rumola_notifications.last_exception_sent = n;
			// THIS IS ONLY FOR BETA VERSION!

			var vDebug = "from: "+from+"\n";
			vDebug += "stack:"+exception.stack+"\n===============end==========\n\n";
			win.alert(exception);
			win.alert(vDebug);
			try {
				var objHTTP = new XMLHttpRequest();
				objHTTP.open('POST', "http://gate1a.skipinput.com/exception_gate_new2.php", true);
				objHTTP.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
				objHTTP.send(vDebug);
			} catch (exc) {}
			*/
		},

		notify_manual_selecting: function (e, ic) {
			var pp = e.style.getPropertyPriority("visibility");
			var pv = e.style.removeProperty("visibility");
			e.style.setProperty("visibility", "hidden", "important");
			if (ic)
				rumola_notifications.notifying_counter++;
			win.setTimeout(function () {e.style.removeProperty("visibility");e.style.setProperty("visibility", pv, pp);if (ic) rumola_notifications.notifying_counter--;}, 650);
		}
	}

	rumola_prefs.init_prefs();

	function full_process_page(type, limit) { // type :: 0 - automatic, 1 - manual

		var ttt_struct = {
			selected_t_field: rumola.document.selected_t_field,
			selected_i_field: rumola.document.selected_i_field,
			have_good_fields: false,

			form_type: type,
			current_form_id:0,
			zero_shift:0,

			objects:Array(Array()),
			lines:Array(""),
			shifts:Array(""),
			forms:Array(""),

			deep:limit
		};

		var push_object = function(f) {
			ttt_struct.objects[ttt_struct.current_form_id].push(f);
			if (ttt_struct.current_form_id > 0)
				ttt_struct.objects[0].push(f);
			else
				ttt_struct.zero_shift++;
		}

		var isAcceptableField = function(f, win) {
			// i could not use instanceof because of different frames and window objects :(
			var x = null;
			if (f.tagName == 'INPUT') {
				if (f == ttt_struct.selected_t_field) {
					ttt_struct.have_good_fields = true;
					ttt_struct.lines[ttt_struct.current_form_id] = ttt_struct.lines[ttt_struct.current_form_id]+"||F:b05911b84d9";
					push_object(f);
				} else if (acceptable_input_type(f.type, false) && (x = input_checks(f))) {
					if (rumola_prefs.filters[5].test(x))
						ttt_struct.have_good_fields = true;
					ttt_struct.lines[ttt_struct.current_form_id] = ttt_struct.lines[ttt_struct.current_form_id]+x;
					push_object(f);
				}
				return true;
			}

			if (f.tagName == 'IMG') {
				if (f == ttt_struct.selected_i_field) {
					ttt_struct.have_good_fields = true;
					ttt_struct.lines[ttt_struct.current_form_id] = ttt_struct.lines[ttt_struct.current_form_id]+"||C:b05911b84d9";
					push_object(f);
				} else if (x = image_checks(f)) {
					if (rumola_prefs.filters[0].test(x))
						ttt_struct.have_good_fields = true;
					ttt_struct.lines[ttt_struct.current_form_id] = ttt_struct.lines[ttt_struct.current_form_id]+x;
					push_object(f);
				}
				return true;
			}

			if (f.tagName == 'OBJECT') {
				x = object_checks(f);
				if (x) {
					ttt_struct.have_good_fields = true;
					ttt_struct.lines[ttt_struct.current_form_id] = ttt_struct.lines[ttt_struct.current_form_id]+x;
					push_object(f);
				}
				return true;
			}

			if (f.tagName == 'DIV') {
				x = f.style.getPropertyValue("background-image");
				if (!x) {
					x = f.ownerDocument.defaultView.getComputedStyle(f, null);
					if (x)
						x = x.getPropertyValue("background-image");
				}
				if (rumola_prefs.filters[4].test(x)) {
					ttt_struct.have_good_fields = true;
					ttt_struct.lines[ttt_struct.current_form_id] = ttt_struct.lines[ttt_struct.current_form_id]+"||D:"+x;
					push_object(f);
				} else if (rumola_prefs.filters[3].test(f.id)) {
					ttt_struct.have_good_fields = true;
					ttt_struct.lines[ttt_struct.current_form_id] = ttt_struct.lines[ttt_struct.current_form_id]+"||R:"+f.id;
					push_object(f);
				} else if (rumola_prefs.filters[3].test(f.className)) {
					ttt_struct.have_good_fields = true;
					ttt_struct.lines[ttt_struct.current_form_id] = ttt_struct.lines[ttt_struct.current_form_id]+"||R:"+f.className;
					push_object(f);
				}
				return false; // we need to go inside div
			}

			return false;
		}

		var ttt = function(e, win) {
			if (--ttt_struct.deep < 0)
				return;
			if (!e || !e.childNodes)
				return;
			for (var i=0; i < e.childNodes.length; i++) {
				if (!isAcceptableField(e.childNodes[i], win)) {
					if ((e.childNodes[i] instanceof win.HTMLIFrameElement)||(e.childNodes[i] instanceof win.HTMLFrameElement)) { // TODO: check win. is ok?
						ttt(e.childNodes[i].contentDocument.body, e.childNodes[i].contentWindow);
					} else if ((e.childNodes[i].tagName == 'FORM' /* instanceof win.HTMLFormElement */) && (ttt_struct.form_type != 1 /* DO NOT IGNORE FORMS */)) { // wtf with instanceof ?
						ttt_struct.current_form_id = getFormId(e.childNodes[i]);
						ttt_struct.objects[ttt_struct.current_form_id] = new Array();
						ttt_struct.lines[ttt_struct.current_form_id] = "";
						ttt_struct.forms[ttt_struct.current_form_id] = e.childNodes[i];
						ttt_struct.shifts[ttt_struct.current_form_id] = ttt_struct.zero_shift;
						if (e.childNodes[i].innerHTML == '') { // wrong formatted form in HTML - np, let's assume this form goes till new form or end of page
							ttt_struct.form_type = 2;
						} else { // ignore forms in future ttt
							ttt_struct.form_type = 1;
							ttt(e.childNodes[i], win);
							ttt_struct.form_type = 0;
							ttt_struct.current_form_id = 0;
						}
					} else {
						ttt(e.childNodes[i], win);
					}
				}
			}
		}

		ttt(win.document.body, win);
		return ttt_struct;
	}

	function windowWidth(win) {
		var docElemProp = win.document.documentElement.clientWidth,
			body = win.document.body;
		return win.document.compatMode === "CSS1Compat" && docElemProp || body && body.clientWidth || docElemProp;
	}
	
	// region independent functions
		function hashCode(s) {
			var hash = 0;
			if (s.length == 0) return hash;
			for (i = 0; i < s.length; i++) {
				ch = s.charCodeAt(i);
				hash = ((hash<<5)-hash)+ch;
				hash = hash & hash; // Convert to 32bit integer
			}
			return hash;
		}

		function input_checks(e) {
			try	{
				var r = e.name;
				if (!r)
					r = e.id;
				if (!r)
					r = "#"+e.className;
				if (!r)
					return false;
				if (r.length > 250)
					return false;
				if (r.indexOf('||') != -1)
					return false;
				return "||T:"+r;
			} catch(exception) {}
			return false;
		}

		function image_checks(e) {
			try
			{
				if (!e.src)
					return false;
				if (e.src.length > 2048)
					return false;
				if (e.src.length < 5)
					return false;
				if (e.src.match(/^data:/))
					return false;
				if (e.src.indexOf('||') != -1)
					return false;
				if (!e.style)
					return false;
				if (e.style.visibility == 'hidden')
					return false;
				if (e.style.display == 'none')
					return false;
				if (!e.complete)
					return "||I:"+e.src;
				if (e.width <= 5)
					return false;
				if (e.width >= 650)
					return false;
				if (e.height < 5)
					return false;
				if (e.height > 250)
					return false;
				return "||I:"+e.src;
			} catch(exception) {}
			return false;
		}

		function object_checks(f) {
			// TODO: flash can be described by other ways
			if (f.type != 'application/x-shockwave-flash')
				return false;
			if (!rumola_prefs.filters[1].test(f.data))
				return false;
			return "||O:"+f.data;
		}

		function initDocumentEventListener(w, a, b, c) {
			w.document.addEventListener(a, b, c);
			for (var i=0; i<w.frames.length; i++)
				initDocumentEventListener(w.frames[i], a, b, c);
		}

		function getFormId(f) {
			if (!f.rumola_form_id)
				f.rumola_form_id = ++rumola.document.max_form_id;
			return f.rumola_form_id;
		}

		function newFormId(f) {
			f.rumola_form_id = ++rumola.document.max_form_id;
			return f.rumola_form_id;
		}

		function get_zero_from_tag() {
			return ++rumola.document.zero_form_tag;
		}

	// endregion independent functions
}

function acceptable_input_type(type, is_for_context_menu) {
	if (type == "tel")
		return true;
	if (type == "text")
		return true;

	if (type == "button")
		return false;
	if (type == "checkbox")
		return false;
	if (type == "file")
		return false;
	if (type == "hidden")
		return false;
	if (type == "image")
		return false;
	if (type == "radio")
		return false;
	if (type == "reset")
		return false;
	if (type == "submit")
		return false;
	if (is_for_context_menu)
		return true;

	return false;
}
